﻿(function (Otime) {

	Otime.Dashboard = new function Dashboard() {
		//		"use strict";

		var _this = this;

		_this.name = "dashboard";

		_this.appModel = null;

		_this.filter_labels = null;

		_this.month_names_short = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

		_this.project_hours = function (data) {
			var self = this;

			data = data || {};
			self.billable_hours = Otime.o(0);
			self.nonbillable_hours = Otime.o(0);
			self.invoiced_hours = Otime.o(0);
			self.uninvoiced_hours = Otime.o(0);
			self.pr_amount = Otime.a([]);

			self.today = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp = Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info = {
				filters: Otime.o(data.filters),
				date_filter_type: Otime.o(data.date_filter_type || _this.dft || "TW"),
				date_filter_disp: Otime.o(_this.filter_labels[data.date_filter_type || _this.dft || "TW"])
			};

			self.refresh = function () {
				var postData = {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf)
				};

				Otime.app.loadData(new Otime.ContextModel('project_hours', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					self.billable_hours(0);
					self.nonbillable_hours(0);
					self.invoiced_hours(0);
					self.uninvoiced_hours(0);

					var tmpArr = [];
					self.max_total = 0;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							self.billable_hours(self.billable_hours() + (val.billable_hours - 0));
							self.nonbillable_hours(self.nonbillable_hours() + (val.nonbillable_hours - 0));

							val.billable_hours = Number(val.billable_hours).toFixed() - 0;
							val.nonbillable_hours = Number(val.nonbillable_hours).toFixed() - 0;
							val.total_hours = val.billable_hours + val.nonbillable_hours;
							self.max_total = (self.max_total > val.total_hours) ? self.max_total : val.total_hours;
							val.billable_hours_per = (val.billable_hours / val.total_hours) * 100;
							tmpArr.push(val);

							if (val.invoiced_hours) {
								self.invoiced_hours(self.invoiced_hours() + (val.invoiced_hours - 0));
								self.uninvoiced_hours(self.uninvoiced_hours() + (val.uninvoiced_hours - 0));
								val.invoiced_hours = Number(val.invoiced_hours).toFixed() - 0;
								val.uninvoiced_hours = Number(val.uninvoiced_hours).toFixed() - 0;
							}
						});
					}
					self.pr_amount(tmpArr.slice());
				}));
			};
			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT(data.date_filter_type || "TY");
		};


		_this.user_hours = function (data) {
			var self = this;

			data = data || {};
			self.billable_hours = Otime.o(0);
			self.nonbillable_hours = Otime.o(0);
			self.invoiced_hours = Otime.o(0);
			self.uninvoiced_hours = Otime.o(0);
			self.pr_amount = Otime.a([]);

			self.today = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp = Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info = {
				filters: Otime.o(data.filters),
				date_filter_type: Otime.o(data.date_filter_type || _this.dft || "TW"),
				date_filter_disp: Otime.o(_this.filter_labels[data.date_filter_type || _this.dft || "TW"])
			};

			self.refresh = function () {
				var postData = {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf)
				};

				Otime.app.loadData(new Otime.ContextModel('project_hours', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					self.billable_hours(0);
					self.nonbillable_hours(0);
					self.invoiced_hours(0);
					self.uninvoiced_hours(0);

					var tmpArr = [];
					self.max_total = 0;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							self.billable_hours(self.billable_hours() + (val.billable_hours - 0));
							self.nonbillable_hours(self.nonbillable_hours() + (val.nonbillable_hours - 0));

							val.billable_hours = Number(val.billable_hours).toFixed() - 0;
							val.nonbillable_hours = Number(val.nonbillable_hours).toFixed() - 0;
							val.total_hours = val.billable_hours + val.nonbillable_hours;
							self.max_total = (self.max_total > val.total_hours) ? self.max_total : val.total_hours;
							val.billable_hours_per = (val.billable_hours / val.total_hours) * 100;
							tmpArr.push(val);

							if (val.invoiced_hours) {
								self.invoiced_hours(self.invoiced_hours() + (val.invoiced_hours - 0));
								self.uninvoiced_hours(self.uninvoiced_hours() + (val.uninvoiced_hours - 0));
								val.invoiced_hours = Number(val.invoiced_hours).toFixed() - 0;
								val.uninvoiced_hours = Number(val.uninvoiced_hours).toFixed() - 0;
							}
						});
					}
					self.pr_amount(tmpArr.slice());
				}));
			};
			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT(data.date_filter_type || "TY");
		};

		_this.output_hours = function (data) {
			var self = this;

			data = data || {};

			self.stackedBar = Otime.a([]);
			self.stack = Otime.o(false);
			self.colors = Otime.a([]);
			self.ticks = Otime.a([]);
			//			self.stackedBar= Otime.a([]);
			self.show_chart = Otime.o(false);
			self.is_team_view = Otime.o(Otime.Dashboard.is_team_view || false);

			self.total = Otime.o(0);
			self.billable = Otime.o(0);
			self.non_billable = Otime.o(0);

			self.today = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp = Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info = {
				filters: Otime.o(data.filters),
				date_filter_type: Otime.o("TM"),
				date_filter_disp: Otime.o(_this.filter_labels["TM"])
			};

			self.refresh = function () {
				var postData = {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf),
					team_view: Number(self.is_team_view())
				};

				Otime.app.loadData(new Otime.ContextModel('output_hrs', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					var bhrs = {};
					var nbhrs = {};
					var tmp_label = [];
					var label = [];
					var k = 0;

					var start_date = new Date(self.date_filter.from_date());
					var end_date = new Date(self.date_filter.to_date());
					var st_mn = end_date.getMonth() - start_date.getMonth();
					var diff = (new Date(end_date - start_date)) / 1000 / 60 / 60 / 24;
					var sql_date = new Date();

					while (end_date.isAfter(start_date) || !end_date.isBefore(start_date)) {
						sql_date = start_date.format(Otime.sdf);
						if (diff > 7 && st_mn) {
							sql_date = _this.month_names_short[start_date.getMonth()];
						} else {
							sql_date = (diff < 7) ? start_date.format(Otime.sdf) : start_date.getDate();
						}
						bhrs[sql_date] = [k, 0];
						nbhrs[sql_date] = [k, 0];
						tmp_label[k] = sql_date;

						if (diff > 7 && st_mn) {
							start_date = start_date.addMonth(1);
						} else {
							sql_date = (diff > 7) ? sql_date : new Date(sql_date).format(Otime.dateFormat);
							start_date = start_date.addDays(1);
						}
						label.push([k, sql_date]);
						k++;
					}

					self.billable(0);
					self.non_billable(0);
					self.total(0);

					if (resp.items && resp.items.length > 0) {
						var date_index = null;
						$.each(resp.items, function (key, val) {
							val.group_entry = Number(val.group_entry) ? Number(val.group_entry) : val.group_entry;
							date_index = tmp_label.indexOf(val.group_entry);
							bhrs[val.group_entry] = [date_index, val.billable_hours];
							nbhrs[val.group_entry] = [date_index, val.nonbillable_hours];
							self.billable(self.billable() + Number(val.billable_hours));
							self.non_billable(self.non_billable() + Number(val.nonbillable_hours));
						});
						self.total(self.billable() + self.non_billable());
					}

					tmpArr.push({ label: 'Billable', data: Object.values(bhrs) });
					tmpArr.push({ label: 'Non-Billable', data: Object.values(nbhrs) });
					var colors = ["#52D793", "#FC8660"];
					self.stack(true);
					self.colors(colors);
					self.ticks(label);
					self.stackedBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};

			self.swap_view = function () {
				self.is_team_view(!self.is_team_view());
				self.refresh();
			}

			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT("TM");
		};

		_this.amount_hours = function (data) {
			var self = this;

			data = data || {};

			self.stackedBar = Otime.a([]);
			self.stack = Otime.o(false);
			self.colors = Otime.a([]);
			self.ticks = Otime.a([]);
			self.show_chart = Otime.o(false);

			//			self.paid			= 	Otime.o(0);
			//			self.unpaid			= 	Otime.o(0);
			//			self.total		= 	Otime.o(0);

			self.today = Otime.o(new Date().format("yyyy/mm/dd"));

			self.refresh = function () {
				var postData = {};

				Otime.app.loadData(new Otime.ContextModel('amount_hours', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					var paid_amount = [];
					var unpaid_amount = [];
					var label = [];
					var k = 0;

					//					self.paid(0);
					//					self.unpaid(0);
					//					self.total(0);

					var tmp_label = [];
					var tmp_incamt = [];
					var tmp_expamt = [];

					var start_date = new Date(self.today());
					var sql_date = new Date();
					k = 5;
					for (var i = 0; i < 6; i++) {
						sql_date = _this.month_names_short[start_date.getMonth()];
						paid_amount[sql_date] = [k, 0];
						unpaid_amount[sql_date] = [k, 0];
						tmp_label[k] = sql_date;
						label.push([k, sql_date]);
						k--;
						start_date = start_date.addMonth(-1);
					}

					if (resp.items && resp.items.length > 0) {
						var date_index = null;
						$.each(resp.items, function (key, val) {
							date_index = tmp_label.indexOf(val.month_str);
							paid_amount[val.month_str] = [date_index, val.paid_amount];
							unpaid_amount[val.month_str] = [date_index, val.unpaid_amount];
						});
					}

					tmpArr.push({ label: 'Paid', data: Object.values(paid_amount) });
					tmpArr.push({ label: 'Unpaid', data: Object.values(unpaid_amount) });
					var colors = ["#CE91DB", "#C96B4C"];
					self.stack(true);
					self.colors(colors);
					self.ticks(label);
					self.stackedBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};
			self.refresh();

		};

		_this.income_expenses = function (data) {
			var self = this;

			data = data || {};

			self.stackedBar = Otime.a([]);
			self.colors = Otime.a([]);
			self.ticks = Otime.a([]);
			self.multiBar = Otime.a([]);
			self.show_chart = Otime.o(false);

			self.total = Otime.o(0);
			self.income = Otime.o(0);
			self.expenses = Otime.o(0);

			self.today = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date = Otime.o(new Date().format("yyyy/mm/dd"));
			self.date_disp = Otime.o(new Date(self.date()).format(Otime.dateFormat));

			self._info = {
				filters: Otime.o(data.filters),
				date_filter_type: Otime.o(data.date_filter_type || _this.exp_dft || "TW"),
				date_filter_disp: Otime.o(_this.filter_labels[data.date_filter_type || _this.exp_dft || "TW"])
			};
			self.refresh = function () {
				var postData = {
					from_date: new Date(self.date_filter.from_date()).format(Otime.sdf),
					to_date: new Date(self.date_filter.to_date()).format(Otime.sdf)
					// team_view: Number(self.is_team_view())
				};

				Otime.app.loadData(new Otime.ContextModel('income_expenses', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					var inc_amount = [];
					var exp_amount = [];
					var label = [];
					var k = 0;

					self.income(0);
					self.expenses(0);
					self.total(0);

					var tmp_label = [];
					var tmp_incamt = [];
					var tmp_expamt = [];

					var start_date = new Date(self.date_filter.from_date());
					var end_date = new Date(self.date_filter.to_date());
					var st_mn = end_date.getMonth() - start_date.getMonth();

					var sql_date = new Date();

					while (end_date.isAfter(start_date) || !end_date.isBefore(start_date)) {
						sql_date = _this.month_names_short[start_date.getMonth()];
						tmp_incamt[sql_date] = [k, 0];
						tmp_expamt[sql_date] = [k, 0];
						tmp_label[k] = sql_date;
						label.push([k, sql_date]);
						k++;
						start_date = start_date.addMonth(1);
					}

					if (resp.items && resp.items.length > 0) {
						var date_index = null;
						$.each(resp.items, function (key, val) {
							date_index = tmp_label.indexOf(val.month_str);
							if (val.inc_amount) {
								tmp_incamt[val.month_str] = [date_index, val.inc_amount];
								self.income(self.income() + Number(val.inc_amount));
							}
							if (val.exp_amount) {
								tmp_expamt[val.month_str] = [date_index, val.exp_amount];
								self.expenses(self.expenses() + Number(val.exp_amount));
							}
						});
						self.total(self.income() - self.expenses());
					}

					tmpArr.push({ label: 'Income', data: Object.values(tmp_incamt) });
					tmpArr.push({ label: 'Expenses', data: Object.values(tmp_expamt) });
					var colors = ["#7cb5ec", "#f7a35c"];
					self.colors(colors);
					self.ticks(label);
					self.multiBar(tmpArr.slice());
					self.show_chart(true);
				}));
			};

			//			self.swap_view	= function() {
			//				self.is_team_view(!self.is_team_view());
			//				self.refresh();
			//			}

			var ie_trg = false;
			var ie_timer = setTimeout(function () {
				ie_trg = true;
				self.refresh();
				self.date_filter.applyDFT(data.date_filter_type || _this.exp_dft || "TW");
			}, 5000);
			$("#main-container").scroll(function () {
				if (ie_trg) return;
				window.clearTimeout(ie_timer);
				self.refresh();
				ie_trg = true;
			});
			Otime.date_filter(self, _this, self.refresh);
			self.date_filter.applyDFT(data.date_filter_type || _this.exp_dft || "TW");

		};


		_this.workload_report = function (data) {
			var self = this;
			data = data || {};

			self.project_id = Otime.o(0);
			self.completed_hours = Otime.o(0);
			self.overdue_hours = Otime.o(0);
			self.remain_hours = Otime.o(0);
			self.pr_workload = Otime.a([]);

			self.refresh = function () {

				var postData = {
					project_id: self.project_id()
				};

				checkTeamId(postData);

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/project/user_workload', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					self.completed_hours(0);
					self.overdue_hours(0);
					self.remain_hours(0);

					var tmpArr = [];
					self.max_total = 0;

					if (resp.user_workload && resp.user_workload.otvalues && resp.user_workload.otvalues.length > 0) {
						resp.items = resp.user_workload.otvalues.setKeys(resp.user_workload.otkeys, function (val) {
							self.completed_hours(self.completed_hours() + (val.comp - 0));
							self.overdue_hours(self.overdue_hours() + (val.overdue - 0));
							self.remain_hours(self.remain_hours() + (val.remain - 0));

							val.comp = Number(val.comp).toFixed() - 0;
							val.overdue = Number(val.overdue).toFixed() - 0;
							val.remain = Number(val.remain).toFixed() - 0;

							val.cnt = val.comp + val.overdue + val.remain;
							self.max_total = (self.max_total > val.cnt) ? self.max_total : val.cnt;
							val.completed_hours_per = (val.comp / val.cnt) * 100;
							val.overdue_hours_per = (val.overdue / val.cnt) * 100;
							val.remain_hours_per = (val.remain / val.cnt) * 100;
							tmpArr.push(val);
						});
					}
					self.pr_workload(tmpArr.slice());
				}), true);
			};
			self.refresh();
		};

		_this.pro_hrs = function (data) {
			var self = this;

			data = data || {};

			self.pieChartArr = Otime.a([]);
			self.project_id = Otime.o(0);
			self.colors = [];
			self.cfields = Otime.a([]);

			self.showCusChart = function (cfield) {
				if (cfield) cfield.is_selected(!cfield.is_selected());
				var selected_fields = [];
				var selected_values = [];
				$.each(self.cfields(), function (key, cfield) {
					if (cfield.is_selected() == true) {
						selected_fields.push(cfield.id());
						selected_values.push(cfield.fName);
					}
				});
				var postData = {
					project_id: self.project_id(),
					fId: selected_fields
				};
				checkTeamId(postData);
				Otime.Storage.set("custom_report", selected_fields);
				var tmpArr = [];
				var color = [];
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/project/dashboard', postData, function (cont) {
					var resp = cont.response;
					self.pieChartArr([]);
					if (resp.items && Object.values(resp.items).length > 0) {
						$.each(resp.items, function (id, chart) {
							tmpArr = [];
							$.each(chart, function (key, item) {
								tmpArr.push({ label: item.name, data: Number(item.hours ? (item.hours - 0) : (item.count - 0)) });
							});
							self.pieChartArr.push({ id: id, fname: selected_values[selected_fields.indexOf(id)], value: tmpArr.slice(), showCusChart: self.showCusChart });
						});
					}

				}), true);
			}

			self.showCustomFilter = function (flag) {
				var postData = {
					project_id: self.project_id()
				};

				checkTeamId(postData);

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/tasks/custom_filters', postData, function (cont) {
					var resp = cont.response;
					var tmpArr = [];
					var filter_report = Otime.Storage.get("custom_report") || ['TT'];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							tmpArr.push({ id: Otime.o(val.id), fName: val.fName, is_selected: Otime.o((filter_report.indexOf(val.id) != -1) ? true : false) });
						});
					}
					self.cfields(tmpArr.slice());
					self.showCusChart();
				}), true);
			};
		};

		/*_this.task_types = function (data) {
			var self = this;

			data = data || {};

			self.pieChart = Otime.a([]);
			self.project_id = Otime.o(data.project_id || 0);
			self.colors = [];

			self.project_id.subscribe(function (newVal) {
				self.refresh();
			});

			self.refresh = function () {
				if (!self.project_id()) {
					return;
				}

				var postData = {
					project_id: self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('task_types', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					var color = [];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (item) {
							var val = [];
							if (item.hours - 0)
								tmpArr.push({ label: item.name, data: Number(item.hours) });

						});
					}
					self.colors = color;

					self.pieChart(tmpArr.slice());
				}));
			};
			//			self.refresh();
		};

		_this.task_status = function (data) {
			var self = this;

			data = data || {};

			self.pieChart = Otime.a([]);
			self.project_id = Otime.o(data.project_id || 0);
			self.colors = [];

			self.project_id.subscribe(function (newVal) {
				self.refresh();
			});

			self.refresh = function () {
				if (!self.project_id()) {
					return;
				}

				var postData = {
					project_id: self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('task_status', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					var color = [];
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (item) {
							var val = [];
							if (!resp.sts_color[item.task_status_id]) {
								return true;
							}
							val = resp.sts_color[item.task_status_id];
							tmpArr.push({ label: val.name, data: Number(item.count) });
							color.push(val.bg_color);

						});
					}
					self.colors = color;

					self.pieChart(tmpArr.slice());
				}));
			};
			//			self.refresh();
		};*/


		_this.project_alertlist = function (data) {
			var self = this;
			data = data || {};

			self.listing = Otime.a([]);
			self.refresh = function () {
				var postData = {
					//project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('project_alerts', postData, function (cont) {
					var resp = cont.response;

					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						var tmpArr = [];
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							var new_alt = new _this.project_alert(val);
							if (new_alt.is_display)
								tmpArr.push(new_alt);
						});
						self.listing(tmpArr);
					}
				}));
			};
			self.refresh();
		}

		_this.project_alert = function (val) {
			var self = this;

			val = val || {};

			self.exe_estcnt = Number(val.exe_estcnt || 0);
			self.exe_datecnt = Number(val.exe_estcnt || 0);
			self.project_name = val.project_name || '';
			self.act_val = 0;
			self.bud_val = 0;
			self.bud_alt_val = val.budget_alert_percent - 0;
			self.bug_type = " " + ((val.budget_type.substr(0, 1) == "A") ? Otime.Currency : "hrs");
			self.is_display = 0;
			self.types = Otime.a([]);
			if (self.bud_alt_val) {
				val.budget_value = val.budget_value * (self.bud_alt_val / 100);
			}
			if (val.actual_value > val.budget_value) {
				self.act_val = Number(val.actual_value).toFixed(2);
				self.bud_val = Number(val.budget_value).toFixed(2);
			}

			if (val.types && val.types.length > 0) {
				var tmpArr = [];
				$.each(val.types, function (key, type) {
					type.act_hrs = Number(type.act_hrs);
					type.estimated_hours = Number(type.estimated_hours);
					if (type.estimated_hours) {
						self.is_display = 1;
					}
					if (type.act_hrs > type.estimated_hours)
						tmpArr.push(type);
				});
				self.types(tmpArr);
			}

			if ((self.bud_val - 0) && (self.exe_estcnt + self.exe_datecnt + self.act_val + self.bud_val + self.types.length) && (self.act_val > (self.bud_val - 0))) {
				self.is_display = 1;
			}
		};

		var checkTeamId = function(postData){
			if (postData && (postData.project_id + "")[0] == "t") {
				postData.team_id = postData.project_id.replace("t", "");
				delete postData.project_id;
			}

			return postData;
		};

		_this.milestones = function (data) {
			var self = this;

			data = data || {};

			//self.listing = Otime.a([]);
			self.my_tasks = Otime.o('');
			self.idle = Otime.o('');
			self.unassigned = Otime.o('');
			self.overdue = Otime.o('');
			self.ms_overdue = Otime.o('');
			self.upcoming = Otime.o('');
			self.project_id = Otime.o(data.project_id || 0);
			self.task_alert = Otime.o(Otime.Storage.get("task_alert") || new Date().format("yyyymmdd"));
			self.task_alert(self.task_alert() - 0);

			self.project_id.subscribe(function (newVal) {
				self.refresh();
			});

			self.task_alert.subscribe(function (newVal) {
				Otime.Storage.set("task_alert", newVal ? new Date().format("yyyymmdd") : 0);
			});

			self.refresh = function () {
				var postData = {
					project_id: self.project_id()
				};

				checkTeamId(postData);

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/' + _this.name + '/tasks_count', postData, function (cont) {
					var resp = cont.response[0];
					self.my_tasks(resp.my_tasks || 0);
					self.idle(resp.idle || 0);
					self.unassigned(resp.unassigned || 0);
					self.overdue(resp.overdue || 0);
					self.ms_overdue(resp.ms_overdue || 0);
					self.upcoming(resp.ms_upcoming || 0);
				}), true);
			};

			/*var ms_trg = false;
			var ms_timer = setTimeout(function() {
				ms_trg=true;
				self.refresh();
			}, 5000);
			$( "#main-container" ).scroll(function() { 
				if (ms_trg) return;
				window.clearTimeout(ms_timer);
				self.refresh();
				ms_trg=true;
			});*/
			self.refresh();
		};

		_this.ProgressCommentsModel = function (data, closeClbk) {
			var self = this;
			data = data || {};
			// "G"-  On Track "O" - Off Track "R" - at Risk
			self.addNewComment = Otime.o(false);
			self.isDashboard = Otime.o(true);
			self.progress_color = {
				G: "green",
				O: "orange",
				R: 'red'
			};
			self.progress_type = [
				{
					status: "On Track",
					value: "G",
				},
				{
					status: "Off Track",
					value: "O"
				},
				{
					status: "At Risk",
					value: "R"
				},
			];
			var pro_types = {
				'G': 'On Track',
				'O': 'Off Track',
				'R': 'At Risk'
			}
			self.progress_comments = Otime.a([]);
			self.progress_comment = {
				message: Otime.o(""),
				status: Otime.o(self.progress_type[0].value)
			};
			self.current_Time = Otime.stoj(new Date(), true);
			self.current_User = Otime.userDetails;
			if (self.current_User.image) {
				self.current_User.image = Otime.UMIP + "/" + self.current_User.image;
			}
			self.addnew = function () {
				self.addNewComment(!self.addNewComment());
			}
			self.readMore = function (data) {
				if (data.show_more()) {
					data.show_more(false);
				} else {
					data.show_more(true);
				}
				if (data.show_less()) {
					data.show_less(false);
				} else {
					data.show_less(true);
				}
				if (data.show_more()) {
					$(".progress-comments #" + data.comment_id).css("-webkit-line-clamp", "3");
				}
				else {
					$(".progress-comments #" + data.comment_id).css("-webkit-line-clamp", "unset");
				}
			}
			self.save = function () {
				if (self.progress_comment.message()) {
					var saveData = {
						module_id: data.project_id,
						message: self.progress_comment.message(),
						module_type: "P",
						parent_comment_id: 0,
						progress_status: self.progress_comment.status() ? self.progress_comment.status() : self.progress_type[0].value,
					};
					// console.log(saveData);
					Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/comments/save", saveData, function (cont) {
						if (cont.response[0]) {
							typeof closeClbk === "function" && closeClbk();
						}
						var resp = cont.response;
						var tmp = {
							"comment_id": resp.comment_id,
							"progress_status": self.progress_comment.status(),
							"date": Otime.stoj(resp.created_date, true),
							"message": self.progress_comment.message(),
							"status_title": self.progress_comment.status() ? pro_types[self.progress_comment.status()] : '',
							"name": Otime.userDetails.name,
						}
						tmp.show_more = Otime.o(false);
						tmp.show_less = Otime.o(false);
						if (tmp.message.length > 250) {
							tmp.show_more = Otime.o(true);
						}
						self.progress_comment.message("");
						self.progress_comment.status(self.progress_type[0].value);
						// typeof closeClbk === "function" && closeClbk();
						self.addnew();
						data.progress_status(tmp.progress_status);
						self.addComment(tmp);
					}), true);
				}
			};
			self.addComment = function (data) {
				var tmpArr = [];
				tmpArr.push(data);
				self.progress_comments().forEach(function (val) {
					tmpArr.push(val);
				});
				self.progress_comments(tmpArr);
			}
			self.close = function () {
				self.progress_comment.message("");
				self.progress_comment.status(self.progress_type[0].value);
				typeof closeClbk === "function" && closeClbk();
			};

			self.addField = function (item) {

			};


			self.remove = function (itm) {
			};
			self.refresh = function (project_id, bindCallBack) {
				// self.stackedBar([]);
				var tmpArr = [];
				var postData = {
					project_id: project_id || self.project_id(),
					history: true
				};

				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/project/progress', postData, function (cont) {
					var resp = cont.response;
					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							val.date = Otime.stoj(val.date, true);
							val.status_title = val.progress_status ? pro_types[val.progress_status] : '';
							val.show_more = Otime.o(false);
							val.show_less = Otime.o(false);
							if (val.message.length > 250) {
								val.show_more = Otime.o(true);
							}
							tmpArr.push(val);
						});
						self.progress_comments(tmpArr);
					}
				}), true);
			};
		};

		_this.pr_milestone = function (data) {
			var self = this;
			data = data || {};
			self.prms_items = Otime.a([]);
			self.pro_rep = Otime.o();
			var pro_types = {
				'G': 'On Track',
				'O': 'Off Track',
				'R': 'At Risk'
			}

			self.refresh = function () {
				var postData = {
				};
				self.max_total = 0;
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/' + _this.name + '/project_milestone', postData, function (cont) {

					var resp = cont.response;

					var tmpArr = [];

					if (resp.items && resp.items.otvalues && resp.items.otvalues.length > 0) {
						resp.items = resp.items.otvalues.setKeys(resp.items.otkeys, function (val) {
							val.mil_per = (val.ms_upcoming / val.cnt) * 100;
							val.progress_status = Otime.o(val.progress_status || "");
							val.status_title = val.progress_status() ? pro_types[val.progress_status()] : '';
							tmpArr.push(val);
							self.max_total = (self.max_total > val.cnt) ? self.max_total : val.cnt;
						});
					}
					self.prms_items(tmpArr.slice());
				}), true);
			};
			self.refresh();
			self.viewReport = function (data) {
				data = data || {}
				var pRep = new _this.ProgressCommentsModel(data, function () {
					$("#progress-modal").modal("hide");
				});
				self.pro_rep(pRep);
				pRep.refresh(data.project_id);
				setTimeout(function () {
					$("#progress-modal").modal('show');
				}, 500);
			}
		};

		_this.outstanding_invoices = function (data) {
			var self = this;

			data = data || {};

			self.listing = Otime.a([]);;
			self.total_due = 0;
			self.refresh = function () {
				var postData = {
					// project_id : self.project_id()
				};

				Otime.app.loadData(new Otime.ContextModel('outstanding_invoices', postData, function (cont) {
					var resp = cont.response;

					var tmpArr = [];
					$.each(resp.items, function (key, val) {
						val = Number(val);
						// if (val) {
						self.total_due = self.total_due + val;
						tmpArr.push({ name: key, amount: val.toFixed(2) });
						// }
					});
					self.listing(tmpArr);
				}));
			};
			self.refresh();
		};

		_this.dashboard = function (data) {
			var self = this;

			self.projects = Otime.a([]);
			self.teams = Otime.a();
			var teams = [];
			$.each(Otime.Details.teams, function(key, val){
				teams.push(Object.assign({
					id: "t" + val.team_id
				}, val));
			});
			self.teams(teams);

			Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + '/' + _this.name + '/details', null, function (cont) {
				var response = cont.response;
				if (response.projects && response.projects.otvalues) {
					response.projects = response.projects.otvalues.setKeys(response.projects.otkeys);
					self.projects(response.projects);

//					var project_id	= response.projects[0].project_id;
//					self.ts_sts().project_id(project_id);
//					self.ty_sts().project_id(project_id);
				}
			}), true);

			self.ts_hrs = Otime.o(new _this.output_hours());
			self.pr_hrs = Otime.o(new _this.project_hours());
			self.milestones = Otime.o(new _this.milestones());
			self.pr_milestone = Otime.o(new _this.pr_milestone());

			if (Otime.usr == 3) {
				self.out_invoices = Otime.o(new _this.outstanding_invoices());
				self.amt_hrs = Otime.o(new _this.amount_hours());
				self.inc_exp = Otime.o(new _this.income_expenses());
			}

			/*self.ts_sts = Otime.o(new _this.task_status());
			self.ty_sts = Otime.o(new _this.task_types());*/

			self.pr_alt = Otime.o(new _this.project_alertlist());
			var work_rep = new _this.workload_report();
			work_rep.project_id = self.milestones().project_id;
			work_rep.project_id.subscribe(function (newVal) {
				work_rep.refresh();
			});
			self.work_rep = Otime.o(work_rep);


			var pro_hrs = new _this.pro_hrs();
			pro_hrs.project_id = self.milestones().project_id;
			pro_hrs.project_id.subscribe(function (newVal) {
				pro_hrs.pieChartArr([]);
				pro_hrs.showCustomFilter(false);
			});
			self.pro_hrs = Otime.o(pro_hrs);
		};

		_this.loadTemplates = function (clbk) {
			var url = Otime.siteUrl + '/dashboard/template';
			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr
			}, function (content) {
				$("#dashboard-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "dashboard_" + Otime.version);
		};

		_this.init = function () {
			var data = {};
			_this.appModel = new _this.dashboard();

			ko.applyBindings(_this.appModel, $("#dashboard-container").get(0));
		};
	};
}(window.Otime));
