(function(Otime){

	Otime.Notification	= new function Notification(){
//		"use strict";

		var _this	= this;

		_this.name	= "notification";

		_this.model	= "NFListModel";

		_this.language	= null;
		
		_this.base_url = null;

		_this.current_view	= "";
		
		_this.module_actions 	= {'C':'commented on ', 'L':'liked ', 'TA' : ' assigned task to ', 'TS' : ' changed task status ', 'TD':' modified task date range ', 'TR' : '', 'HS': ' submitted <strong>timesheet</strong> for approval','HR':' rejected your timesheets','ES': ' submitted <strong>expenses</strong> for approval', 'A':' acknowledged ','OA':' posted a new announcement','UT':' tagged you in a '};
		_this.module_types 		= {'C':'comment', 'O':'post','T':'', 'H':'', 'E':'', 'A':'Announcement'};
		_this.page 				= 0;

		_this.NFListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.items	= Otime.a([]);
			self.pendingRequest = Otime.o(false);
			
			self.scrolled = function(data, event) {
				var elem = event.target;
				if (!self.pendingRequest() && elem.scrollTop > (elem.scrollHeight - elem.offsetHeight - 5))
				{
					self.getItems();
				}
			};
			
			self.load_post = function (item) {
				//$('#notification_popup').show();
				/*if (item.post_id()) {
					Otime.Post.appModel.showPost(item.post_id());	
				}*/
//				if (item.post_id()) {
					switch(item.module_type()) {
						case 'T':
							if (item.post_id())
								window.location = Otime.siteUrl+'/tasks/'+item.post_id();
						break;
						case 'H':
							if (item.module_action()!='HR')
								window.location = Otime.siteUrl+'/timesheet/approve';
							else
								window.location = Otime.siteUrl+'/timesheet';
						break;
						case 'E':
							window.location = Otime.siteUrl+'/expenses';
						break;	
						default:
							if (item.post_id())
							{
								// var ntf_url	= Otime.baseUrl.replace('/outputtime/','')+'/wall?post=' + item.post_id() + '&post_only=1';
								if (window.location.href.indexOf("/wall") && $("#wall_frame").get(0))
								{
									var iframeSrc	= $("#wall_frame").attr("src");
									if (iframeSrc.match(/[\?|\&]post=(\d+)/))
									{
										iframeSrc	= iframeSrc.replace(/([\&|\?])post=(\d+)/, "$1post=" + item.post_id());
									}
									else
									{
										iframeSrc	= iframeSrc + "&post=" + item.post_id();
									}
									$("#wall_frame").attr("src", iframeSrc);
								}
								else
								{
									Otime.Menu.loadURL("wall?post=" + item.post_id());
								}
/*
								var html = '';
								html	+= '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>';
								html	+= '<iframe id="notification_wall_frame" style="width:100%;height:100%;border:0px;" src="' + ntf_url + '"></iframe>';
								$('#notification_popup .modal-body').html(html);
								$('#notification_popup').modal('show');
*/
							}
						break;
					}				
				// }
			}
			
			self.getItems = function() {
				if (!_this.page) {
					self.items([]);
				}
				self.pendingRequest(true);
				// $("#notification-list").unbind("mouseleave");
				$.get(Otime.siteUrl+"/notify/notification/"+_this.page, function(resp){
					self.pendingRequest(false);
					/*$("#notification-list").mouseleave(function(){
						$("#notification").click();
					});*/
					if (!resp || !resp[2].items || !resp[2].items.length)
					{
						_this.page=0;
						self.pendingRequest(true);
						return false;
					}

					var tmpList	= [];
					var nf_ids 	= [];
					
					$.each(resp[2].items, function(key, val){
						tmpList.push(new _this.NFContentModel(val));
						/*if (!(val.is_read-0))
							nf_ids.push(val.notification_id);*/
					});
					Otime.notific_last_read = tmpList[0].notification_id;
					/*var user_notification_count = 0;*/
					Otime.notificationCount = 0;
					$('#notification .user-notify-cnt').hide();
					
					/*if (nf_ids.length) {
						user_notification_count -= nf_ids.length;
						if (user_notification_count<=0) {
							user_notification_count = 0;
							$('#notification .user-notify-cnt').hide();
						} else {
							$('#notification .user-notify-cnt').text(user_notification_count).show();
						}
						
						$.post(Otime.api_url+"notification_update", {ids:nf_ids}, function(resp){
							// return true;
						});
					}*/

					if (tmpList) {
						self.items.append(tmpList);
					}
					if (!_this.page)
						_this.container.show();
					_this.page++;
					return;
				});	
			}
			
			
		};

		_this.NFContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.id			= Otime.o(data.notification_id-0 || 0);
			self.notes		= Otime.o(data.notes || "");
			// self.is_read		= Otime.o(data.is_read-0 || 0);
			self.is_read		= Otime.o(self.id() >Otime.notific_last_read?0:1);
			self.post_id		= Otime.o(data.post_id || 0);
			self.module_type	= Otime.o(data.module_type || '');
			self.date		= new Date(data.posted_on*1000);
			self.module_action	= Otime.o(data.module_action || '');
			
			data.post_user		= 0;
			if (data.post_by) {
				var post_by		= data.post_by;
				data.post_by 	= data.post_by.replace(/\d+#/g,'');
				data.post_by 	= data.post_by.replace(/(^,)|(,$)/g, "");
				if (data.post_by) {
					data.post_user = post_by.match(/\d+#/)[0].replace('#','');
					data.post_count = data.post_by.split(',').length-1;
				}
			}

			var usr	= Otime.Details.all_users[data.post_user];
			self._info	= {
				user_image: usr.user_image,
				user_name: usr.user_name
			};
			if (usr.user_image)
				self._info.user_image = Otime.UMIP + usr.user_image;
			else
				self._info.user_image = Otime.baseUrl + "invalid/noUser.png";
				
			self.post_by		= Otime.o(data.post_by || '');
			self.post_count		= Otime.o(data.post_count || 0);
			self.nfy_msg		= Otime.o('');
			
			data.created_by =  data.created_by-0 || 0;

			if (self.module_action()) {
				var pre_text = self.post_by().split(',').join(', ');
				var usr_cnt = 0;
				if (data.post_count>1) {
					var nm_cnt = data.post_count<=2?data.post_count:1;
					nm_cnt++;
					pre_text = 	self.post_by().split(',',nm_cnt).join(', ');
					nm_cnt--;
					usr_cnt = self.post_count()-nm_cnt;
				}
				pre_text = '<strong>'+pre_text+'</strong>';
				if (usr_cnt) {
						pre_text +=  ' and <strong>'+usr_cnt+((usr_cnt>1)?' others':' other')+'</strong> also';
				}
				
				var created_by = '';
				if (data.module_type!='T') {
					created_by = data.created_by==Otime.UID?' your ':'';
					if (!created_by && Otime.Details.all_users[data.created_by]) {
						created_by = ' <strong>'+Otime.Details.all_users[data.created_by].user_name+'</strong> ';
					}
				} else {
					created_by = pre_text;
					if (self.module_action()=='TA') {
						//created_by = data.created_by==Otime.UID?' you ':'';
						if (!created_by && Otime.Details.all_users[data.created_by]) {
							created_by = ' <strong>'+Otime.Details.all_users[data.created_by].user_name+'</strong> ';
						}
					}
				}
								
				if (!data.notes) {
					switch (self.module_action()) {
						case 'OA':
							pre_text+=' '+_this.module_actions[self.module_action()];
						break;
						case 'UT':
							pre_text+=' '+_this.module_actions[self.module_action()]+' '+_this.module_types[data.module_type];
						break;
						default:
							pre_text+=' '+_this.module_actions[self.module_action()]+' '+created_by+_this.module_types[data.module_type];
					}
				} else {
					pre_text = created_by+' '+data.notes; 
				}
				self.nfy_msg(pre_text+(data.subject?('<div class="dark_text">'+(data.subject.length>50?data.subject.substring(0,50)+'..':data.subject)+'</div>'):''));
			}
		};

		_this.model	= Otime.o(null);

		_this.init	= function(){
			_this.container	= $("#notification-container");

			if (_this.container.is(":visible"))
			{
				_this.container.hide();
				_this.page = 0;
			}
			else
			{
				if (ko.dataFor(_this.container.get(0)) == undefined)
				{
					_this.model(new _this.NFListModel());
					ko.applyBindings(_this.model, _this.container.get(0));
				}
				
				_this.model().getItems();			
			}
/*
			$('#notification_popup').on('hidden.bs.modal', function () {
				$("#notification").addClass('open');
				$('#notification-container').show();
			});
*/
		};

	};

}(window.Otime));
