(function(Otime){

	Otime.Users	= new function Users(){
//		"use strict";

		var _this	= this;

		_this.name	= "users";

		_this.model	= "UsersListModel";

		_this.language	= null;

		_this.user_roles	= null;

		_this.searchArray	= {};

		_this.user_id		= null;

		_this.fileApi		= null;

		_this._cropObj	= null;

		_this.UID	= 0;

		_this.addNew	= function(){
			_this.listModel.addItem();
		};

		_this.ids	= [];

		_this.applyFileApi	= function(item){
			if (!_this.fileApi)
			{
				_this.fileApi	= new FileAPI({
					imageOnly: true
				});
			}

			_this.fileApi.onAddFile	= function(param){
				var reader = new FileReader();
				reader.onload = function(e){
					item.user_image_path(e.target.result);

					$("#crop_image").modal({
						backdrop: "static",
						show: true
					});
					$('#crop_image').on('hidden.bs.modal', function(){
						item.profile_image("");

						item.user_image_path(item.oldImage() || (Otime.baseUrl + '/files/photo/noImg.png'));
						item.oldImage(item.oldImage() || (Otime.baseUrl + '/files/photo/noImg.png'));
					});
					_this._cropObj	= new _this.CropImage();
					_this._cropObj.init();
				};
				reader.readAsDataURL(_this.fileApi.fileQueue[0].file);
			};

			_this.fileApi.onRemoveFile	= function(){
				item.user_image_path(item.oldImage());
				item.profile_image(null);
			};

			_this.fileApi.fileField	= $("#profile_image", _this.edit_container).get(0);
			_this.fileApi.buttonClass	= "dn";
			_this.fileApi.init();
		};

		_this.removeImage	= function(item){
			item	= item || _this.appModel.selectedItem();
			item.profile_image("");
			item.user_image("");

			item.user_image_path(Otime.baseUrl + '/files/photo/noImg.png');
			item.oldImage(Otime.baseUrl + '/files/photo/noImg.png');
			$("#target-prof-img").css({
				"margin-left": 0,
				"margin-top": 0,
				"height": "100%",
				"width": "100%"
			});
		};

		_this.UsersListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.is_list_view	= Otime.o(false);

			self.items	= Otime.a([]);

			self.departments = Otime.a();

			self.selectedItem	= Otime.o(null);

			self.is_new_mode	= Otime.o(false);
			self.is_edit_mode	= Otime.o(false);
			self.show_loading	= Otime.o(false);
			self.is_comment_mode	= Otime.o(false);

			self.is_add_permission	= Otime.o(true);
			self.loading	= Otime.o(false);
			self.show_more	= Otime.o(false);
			self.finish	= Otime.o(true);
			self.proj_finish	= Otime.o(false);
			self.page	= 1;
			self.archive_count	= Otime.o(0);
			self.active_count	= Otime.o(0);
			self.active 		= Otime.o(1);

			self.swapView	= function(){
				self.is_list_view(!self.is_list_view());
				self.is_comment_mode(false);
			};

			self.load_more	= function(){
				self.page++;
				var data = { active: self.active() };
				Otime.app.loadData(new Otime.ContextModel("listing/" + self.page, data, function(cont){
					var response	= cont.response;
					_this.ids = [];
					self.finish(response.finish || false);
					if (response.finish == true)
					{
						self.show_more(false);
					}
					if (response.items && response.items.otvalues && Object.keys(response.items.otvalues).length > 0)
					{
						var tmpArr	= [];
						response.items	= response.items.otvalues.setKeys(response.items.otkeys, function(itm){
							if (_this.ids.indexOf(itm.user_id-0) >= 0)
								return true;
							itm.is_ts_posted = itm.hours >0 ?true:false;
							self.items.push(new _this.UsersContentModel(itm, self));
						});
					}
					_this.users_container.masonry('reload');
				}));
			};

			self.proj_page	= 1;
			self.load_more_projects	= function(){
				self.proj_page++;
				Otime.app.loadData(new Otime.ContextModel("get_projects/" + _this.user_id() + "/" + self.proj_page, null, function(cont){
					self.proj_finish(cont.response.finish || false);

					var item	= self.selectedItem();
					if (cont.response.items && cont.response.items.otvalues && Object.keys(cont.response.items.otvalues).length > 0)
					{
						cont.response.items	= cont.response.items.otvalues.setKeys(cont.response.items.otkeys, function(itm){
							item._project.items.push(new _this.ProjectsInfoModel(itm));
						});
					}
					item._project.proj_page(self.proj_page);
					if (cont.response.finish == true)
					{
						item._project.view_more(false);
					}
				}));
			};

			self.addItem	= function(){
				self.is_new_mode(true);
				self.editItem(new _this.UsersContentModel({is_edit_permission:true}, self));
			};

			self.cropApply	= function(item){
				item	= self.selectedItem();
				if (_this._cropObj)
				{
					item.cropData(_this._cropObj.getCropData());
				}
			};

			self.editItem	= function(item){
				if (item.is_active() == 0)
				{
					return false;
				}
				self.is_comment_mode(false);
				if (item && !item._info.is_edit_permission())
				{
					return false;
				}

				var tmplClbk	= function(){
					var usrId	= item.user_id();
					if (isNaN(usrId) || usrId <= 0)
					{
						self.selectedItem(new _this.UsersContentModel({is_edit_permission:true}, self));
						self.edit(self.selectedItem());

						var itm	= self.selectedItem();
						var arr	= [],
							val	= null;
						$.each(Otime.Details.all_projects, function(key, project){
							if (project.is_active && project.user_role != "M")
							{
								val	= JSON.parse(JSON.stringify(project));
								val.user_role	= itm.user_role();
								val.is_assigned = project.all_users - 0;
								arr.push(new _this.ProjectItemModel(val, itm));
							}
						});
						itm.projects(arr);
					}
					else
					{
						Otime.Menu.ReplaceURL(_this.name + "/" + usrId);
						self.selectedItem(item);
						var context	= new Otime.ContextModel('edit/' + usrId, null, self.load);
						context.mode	= "EDIT";
						Otime.app.loadData(context);
						self.proj_page	= 1;
					}
					_this.fileApi.fileField	= $("#profile_image", _this.edit_container).get(0);
					_this.fileApi.init();
					_this.applyFileApi(self.selectedItem());
				};

				if (!Otime.app.hasBinding(_this.edit_container))
				{
					Otime.app.load_template("edit", function(response){
						_this.edit_container.html($.trim(response));

						if (self.selectedItem() == null)
						{
							self.selectedItem(new _this.UsersContentModel({is_edit_permission:true}, self));
						}

						ko.applyBindings({targetItem:self.selectedItem}, _this.edit_container.get(0));
						tmplClbk();
					});
					return false;
				}
				tmplClbk();
			};

			var lastScroll = 0;
			self.edit	= function(item){
				lastScroll	= _this.mainContainer.get(0).scrollTop;
				item	= item || self.selectedItem();
				// 3rd param is ignoreList
				ko.editable(item, undefined, ["projects", "_info", "_project", "hasChanges", "cropData", "user_roles", "role_disp"]);
				item.beginEdit();
				self.is_edit_mode(true);
				$("#target-prof-img").css({width: '100%', height: 'auto', marginLeft: 0, marginTop: 0});
				_this.mainContainer.get(0).scrollTop	= 0;
			};

			self.deleteItem	= function(item){
				if (item.hours()-0 > 0)
				{
					alert("You can't delete this user.");
					return false;
				}

				if(item.user_id() && confirm(_this.language["CONFIRM_DELETE_USER"]))
				{
					Otime.app.postData(new Otime.ContextModel("delete/" + item.user_id(), null, function(){
						self.items.remove(item);
						self.is_edit_mode(false);
						_this.users_container.masonry('reload');
					}));
				}
			};

			self.reset	= function(item){
				if(item.user_id() && confirm(_this.language["CONFIRM_RESET_PASSWORD"]))
				{
					Otime.app.postData(new Otime.ContextModel("reset/" + item.user_id(), null, function(){
						self.is_edit_mode(false);
					}));
				}
			};

			/*self.lock	= function(item){
				item	= self.selectedItem();
				var url	= (item.is_active() ? "lock" : "unlock");
				Otime.app.postData(new Otime.ContextModel(url + "/" + item.user_id(), null, function(){
					item.is_active(Number(!item.is_active()));
				}));

				return true;
			};*/

			self.archiveItem = function(val) {

				return function(item, elem){
//					item	= self.selectedItem();
					if(val==1)
					{
						var msg = _this.language["UNARCHIVE_USER_CONFIRM_MSG"];
						var url = "unlock";
					}
					else
					{
						var msg = _this.language["ARCHIVE_USER_CONFIRM_MSG"];
						var url = "lock";
					}

					if (item.user_id() > 0 && confirm(msg) == true)
					{
						Otime.app.postData(new Otime.ContextModel({
							url: url + "/" + item.user_id(),
							global: false
						}, {
							is_active: val
						}, function(){
							item.is_active(val);
							self.items.remove(item);

							if (!self.is_list_view() || self.is_edit_mode())
							{
								self.is_edit_mode(false);
								_this.users_container.masonry('reload');
								Otime.Menu.ReplaceURL(_this.name);
							}

							if(val == 1)
							{
								self.archive_count(Number(self.archive_count())-1);
								self.active_count(Number(self.active_count())+1);
								if(self.archive_count()<=0)
								{
									self.active(0);
								}
							}
							else
							{
								self.active_count(Number(self.active_count())-1);
								self.archive_count(Number(self.archive_count())+1);
								if(self.active_count()<=0)
								{
									self.active(1);
								}
							}

							if (Otime.Details.all_users && Otime.Details.all_users[item.user_id()])
							{
								Otime.Details.all_users[item.user_id()].is_active = !!(val-0);
							}
						}));
						return true;
					}
				};
			};

			self.is_valid	= function(item){
				item.first_name(item.first_name().charAt(0).toUpperCase() + item.first_name().slice(1));
				return (item.first_name.isValid() && item.email.isValid() && item.user_role() != '0');
			};

			self.removeImage	= function(item){
				_this.removeImage(self.selectedItem());
			};

			self.ActivityHandler	= Otime.o(null);
			var initCommentsActivity	= function(item, elem){
				var rp	= item.rp();
				if (!rp)
				{
					self.ActivityHandler(Otime.Comments.init({
						module: "users",
						module_type: "P,T,I,LN,LO",
						filters: {
							user_id: item.user_id()
						},
						filter: "activity",
						model: item,
						isSeparate: true,
						c_limit:10,
						noBind: true,
						close: function(){
							self.show_activity(item, elem);
						}
					}));
					rp	= item.rp();
				}
				rp.paneType(rp.paneTypes.ACTIVITY);
			};

			self.show_activity	= function(item, elem){
//				item	= self.selectedItem();
				if (_this.listModel.is_comment_mode())
				{
					_this.listModel.is_comment_mode(false);
					$('#comment_layout').addClass('closed').removeClass('opened');
					return true;
				}
				initCommentsActivity(item, elem);
				_this.listModel.is_comment_mode(true);
				$('#comment_layout').addClass('opened').removeClass('closed');
			};

			self.prepareData	= function(){
				return _this.prepareData(self.selectedItem());
			};

			self.cancel	= function(item, elem){
				item	= self.selectedItem();
				item.rollback();
				self.swapMode();
				self.is_comment_mode(false);

				if (!item.oldImage())
				{
					item.user_image_path(Otime.baseUrl + '/files/photo/noImg.png');
					item.oldImage(Otime.baseUrl + '/files/photo/noImg.png');
				}
				else
				{
					item.user_image_path(item.oldImage());
				}

				$('#comment_layout').addClass('closed').removeClass('opened');
				_this.users_container.masonry('reload');
				_this.mainContainer.get(0).scrollTop	= lastScroll;
				Otime.Menu.ReplaceURL(_this.name);
			};

			self.save	= function(item){
				//if (self.hasChanges() == true && self.is_valid() == true)
				/*if (item && !item._info.is_edit_permission())
				{
					return false;
				}*/
				item	= self.selectedItem();
				if(self.is_valid(item) == true)
				{
					var comp_image	= item.profile_image();
					if(comp_image && item.hasChanges() == true)
					{
//						Otime.Users.fileApi.params	= {cropData: item.cropData()};
						_this.fileApi.url	= Otime.siteUrl+'/attachment/users_image_upload/'+(item.user_id())+ '/?cropData=' + JSON.stringify(item.cropData());
						_this.fileApi.onAfterUpload	= function(data){
							if (data && !data[0])
							{
								Otime.error_message(data[1], $("#alert_message"));
								// error(data[1]);
								return;
							}
							$("#target-prof-img").css({
								width: '100%',
								height: '100%',
								marginLeft: '0px',
								marginTop: '0px'
							});
							item.user_image(data[2].file_name);
							item.user_image_path(Otime.UMIP + data[2].file_name + "?time=" + new Date().getTime());
							item.oldImage(Otime.UMIP + data[2].file_name + "?time=" + new Date().getTime());
							_this.saveCallback(item, self, function(){
								_this.mainContainer.get(0).scrollTop	= lastScroll;
							});
						};
						_this.fileApi.uploadQueue();
					}
					else
					{
						//Otime.Users.fileApi.url	= Otime.siteUrl+'/attachment/users_image_upload/'+self.first_name()+self.last_name();
						_this.saveCallback(item, self, function(){
							_this.mainContainer.get(0).scrollTop	= lastScroll;
						});
					}
				}
				else
				{
					if(item.email.isValid() == false && item.email())
						alert('Invalid Email id');
					else
						alert("Required field missing, please check.");
					return false;
				}

				return true;
			};

			self.swapMode	= function(){
				self.selectedItem(new _this.UsersContentModel(null, self));
				self.is_edit_mode(false);
				self.is_new_mode(false);
				// $("#users-edit-container").css('');
				_this.mainContainer.css('overflow','auto');
			};

			self.load	= function(context){
				var item	= self.selectedItem();
				var data	= context.response || {};

				if (data)
				{ 
					item.user_id(data.user_id || item.user_id());
					item.first_name(data.first_name || item.first_name());
					item.first_name(item.first_name().charAt(0).toUpperCase() + item.first_name().slice(1));
					item.last_name(data.last_name || item.last_name());
					item.email(data.email || item.email());
					item.department(data.department || item.department());
					item.time_zone_code(data.time_zone_code || item.time_zone_code());
					item.user_image((data.user_image && data.user_image != '') ? data.user_image : item.user_image());
					item.user_image_path((data.user_image && data.user_image != '/files/photo/noImg.png') ? Otime.UMIP + data.user_image : item.user_image());
					item.oldImage((data.user_image && data.user_image != '/files/photo/noImg.png') ? Otime.UMIP + data.user_image :  item.user_image());
					item.hourly_rate(data.hourly_rate || item.hourly_rate());
					item.hourly_cost(data.hourly_cost || item.hourly_cost());
					item.is_active(data.is_active || item.is_active());
					item.user_role(data.user_role || item.user_role());
					item.edit_role_permission(data.edit_role_permission);
					if (data.dob) {
						data.dob =  Otime.stoj(data.dob);
					}
					if (data.doj) {
						data.doj =  Otime.stoj(data.doj);
					}
					item.dob(data.dob || item.dob());
					item.doj(data.doj || item.doj());

//					if (data.mail_subscription && data.mail_subscription.otvalues)
//					{
//						var mails	= data.mail_subscription.otvalues.setKeys(data.mail_subscription.otkeys, null, "mail_type");
//
//						if (mails['W'])
//						{
//							// item.is_weekly_mail(!!(mails['W']["is_subscribed"]-0));
//						}
//					}
				}

				var selectedProjects	= {};
				if (data.project_user_map && data.project_user_map.otvalues)
				{
					data.project_user_map.otvalues.setKeys(data.project_user_map.otkeys, function(itm){
						selectedProjects[itm.project_id]	= itm;
					});
				}

				if (data.projects_info)
				{
					item._project.active_projects(data.projects_info.active_projects || 0);
					item._project.total_hours(data.projects_info.total_hours || 0);
					item._project.billable(data.projects_info.billable || 0);
					item._project.in_active_projects(data.projects_info.in_active_projects || 0);
					item._project.total_projects(data.projects_info.total_projects || 0);
					item._project.in_active_projects(data.projects_info.in_active_projects || 0);
					item._project.view_more(data.projects_info.view_more || false);
					item._project.items([]);

					if (data.projects_info.items && data.projects_info.items.otvalues)
					{
						var tmpArr	= [];
						data.projects_info.items.otvalues.setKeys(data.projects_info.items.otkeys, function(itm){
							tmpArr.push(new _this.ProjectsInfoModel(itm));
						});
						item._project.items(tmpArr);
					}
				}
// SURESH
				var arr	= [],
					val	= null,
					selected	= null;
				$.each(Otime.Details.all_projects, function(key, project){
					if (project.is_active && project.user_role != "M")
					{
						val	= JSON.parse(JSON.stringify(project));

						val.user_role	= item.user_role();
						selected	= selectedProjects[val.project_id];
						if (selected)
						{
							val.is_assigned	= true;
							val.user_role	= selected.user_role;
							val.project_user_id	= selected.project_user_id;
							val.actual_hours	= selected.actual_hours;
							val.hourly_rate		= selected.hourly_rate;
						}
						arr.push(new _this.ProjectItemModel(val, item));
					}
				});
				item.projects(arr);

				if (data.info)
				{
					item._info.is_edit_permission(data.info.is_edit_permission || item._info.is_edit_permission());
					item._info.user_role(data.info.user_role || item._info.user_role());
					item._info.amount(data.info.amount || item._info.amount());
					item._info.pagination.more(data.info.pagination.more || item._info.pagination.more());
				}

				if (context.mode == "EDIT")
				{
					self.edit(item);
					_this.user_id(item.user_id());
				}
			};
//			var getUserID	= function(data){
//				var matches	= location.pathname.match(/users\/(\d+)/);
//				if (matches && undefined != matches[1] && !isNaN(matches[1]))
//				{
//					data.user_id	= matches[1];
//				}
//				return data;
//			};

			self.refresh	= function(active){
				Otime.app.postData(new Otime.ContextModel({
					url: "listing",
					data: {
						active: active,
						onInit: 1
					},
					callback: function(cont){
						var resp	= cont.response,
							flag0	= false;

						self.finish(!!resp.finish);
						self.page	= 1;
						if (resp.items && resp.items.otvalues && resp.items.otvalues.length>0)
						{
							var tmpArr	= [],
								tmpModel	= null;
							resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
								// For enable | disable "Delete" Menu item.
								// If user posted timesheet then Delete User will restrict.
								/*itm.is_ts_posted	= resp.user_hours.otvalues?(resp.user_hours.otvalues.indexOf(itm.user_id) >= 0):0;*/
								itm.is_ts_posted = itm.hours >0 ?true:false;
								tmpModel	= new _this.UsersContentModel(itm, self);
								if (_this.UID == tmpModel.user_id())
								{
									flag0	= true;
									self.selectedItem(tmpModel);
								}
								tmpArr.push(tmpModel);
							});
							self.items(tmpArr);
						}

						/*
						_this.searchArray	= {
							departments: []
						};
						*/

						if (Object.keys(resp.departments).length > 0)
						{
							var lbl	= "";
							var departments = [];
							$.each(resp.departments, function(key, val){
								lbl	= val.department;
								departments.push({
									label : lbl,
									value : val.user_dept_id,
									id : val.user_dept_id
								});
							});
							self.departments(departments);
						}

						if(active == 1)
						{
							self.archive_count(resp.archive_count);
						}
						else
						{
							self.active_count(resp.active_count);
						}
						self.active(active);

						if (Otime.Menu.is_new)
						{
							self.addItem();
							Otime.Menu.is_new	= null;
						}
						_this.users_container.masonry('reload');

						if (flag0)
						{
							flag0	= false;
							_this.UID	= 0;
							self.editItem(self.selectedItem());
						}
						else if (_this.UID)
						{
							var tmpModel	= new _this.UsersContentModel({
								user_id: _this.UID-0,
								is_active: true,
								is_edit_permission:true
							}, self);
							tmpArr.push(tmpModel);
							self.selectedItem(tmpModel);
							self.editItem(tmpModel);
						}
					}
				}));
			};

			self.refresh(self.active());
		};

		_this.CropImage	= function(){
			var self	= this;

			var cropData	= null;
			var jcrop_api, boundx, boundy, xsize, ysize, owidth, oheight;
			var _cropFn	= function(){
				var _img	= $("#target");
				if (_img.data("Jcrop"))
				{
					_img.data("Jcrop").destroy();
				}

				var $preview	= $('#preview-pane'),
					$pcnt		= $('#preview-pane .preview-container'),
					$pimg		= $('#preview-pane .preview-container img');
				xsize	= $pcnt.width(),
				ysize	= $pcnt.height();

				var tmpImg	= new Image();
				tmpImg.onload	= function(){
				    owidth	= this.width;
				    oheight	= this.height;
				};
				tmpImg.src	= _img.attr("src");

				$pimg.css({width: '100%', height: '100%', marginLeft: 0, marginTop: 0 });

				var updatePreview	= function(c){
					cropData	= c;
					if (parseInt(c.w) > 0)
					{
						var rx = xsize / c.w;
						var ry = ysize / c.h;

						$pimg.css({
							width: Math.round(rx * boundx) + 'px',
							height: Math.round(ry * boundy) + 'px',
							marginLeft: '-' + Math.round(rx * c.x) + 'px',
							marginTop: '-' + Math.round(ry * c.y) + 'px'
						});
					}
				};

				var centerImage	= function(){
					_img	= $("#target");

					var viewPort	= $("#crop_image .jcrop-holder");
					var allImg	= $("#crop_image img");//.not("#preview-pane img");

					var image_width		= _img.width(),
						image_height	= _img.height(),
						crop_width		= 300, //viewPort.width(),
						crop_height		= 300; //viewPort.height();

					if (image_width < image_height)
					{
						image_height = crop_height;
						allImg.height(image_height);
						allImg.width("auto");
						image_width = allImg.width();
					}
					else
					{
						image_width = crop_width;
						allImg.width(image_width);
						allImg.height("auto");
						image_height = allImg.height();
					}
				}

				$('#target').Jcrop({
					bgColor: '',
					bgOpacity: '1',
					minSelect: [10,10],
					aspectRatio: 1, //xsize / ysize
					setSelect: [100,100, 200, 200],
					onChange: updatePreview,
					onSelect: updatePreview,
					onBeforeProcess: function($img){
						centerImage();
					}
				},function(){
					var bounds	= this.getBounds();
					boundx	= bounds[0];
					boundy	= bounds[1];
					jcrop_api	= this;
				});
				updatePreview(cropData);
			};

			self.getCropData	= function(){
				var c	= cropData;
				if (parseInt(c.w) > 0)
				{
					var rx = xsize / c.w;
					var ry = ysize / c.h;
					$("#target-prof-img").removeClass("noImg").css({
						width: Math.round(rx * boundx) + 'px',
						height: Math.round(ry * boundy) + 'px',
						marginLeft: '-' + Math.round(rx * c.x) + 'px',
						marginTop: '-' + Math.round(ry * c.y) + 'px'
					});

					cropData.ow	= owidth;
					cropData.oh	= oheight;
					cropData.x	= Math.round(rx * c.x);
					cropData.y	= Math.round(ry * c.y);
					cropData.cw	= Math.round(rx * boundx);
					cropData.ch	= Math.round(ry * boundy);
					cropData.w	= Math.round(rx * c.x2) - cropData.x;
					cropData.h	= Math.round(ry * c.y2) - cropData.y;

					$('#crop_image').unbind('hidden.bs.modal').modal('hide');
					$("#target").data("Jcrop").destroy();
				}
				return cropData;
			};

			self.init	= function(){
				_cropFn();
			};
		};

		_this.prepareData	= function(item){
			var projects_map	= [];
			var projects_remove	= [];

			$.each(item.projects(), function(key, val){
				if (!val.isDirty())
					return true;

				if (val.is_assigned())
				{
					projects_map.push({
						project_user_id: val.project_user_id()-0,
						project_id: val.project_id()-0,
						hourly_rate: val.hourly_rate()-0,
						user_role: val.user_role()
					});
				}
				else if(val.project_user_id()-0)
				{
					projects_remove.push(val.project_id());
				}
			});
/*
			var data	= JSON.parse(ko.toJSON(item));
			delete data.projects;
			delete data._info;
			delete data._project;
			delete data.hasChanges;
			delete data.cropData;
			delete data.user_roles;
			delete data.role_disp;

			// data.is_weekly_mail	= data.is_weekly_mail ? "1" : "0";
*/
			var data	= {};
			var fields	= ["user_id", "first_name", "last_name", "email", "password", "confirm_password", "time_zone_code", "user_dept_id", "user_image", "user_role", "is_active", "hours", "hourly_rate", "hourly_cost", "department"];

			for (var i=0, iLen=fields.length; i<iLen; i++)
			{
				if (item[fields[i]])
				{
					data[fields[i]]	= item[fields[i]]();
				}
			}
			if(item.dob()) {
				data.dob = new Date(item.dob()).format('YYYY-MM-DD')
			}
			if(item.doj()) {
				data.doj = new Date(item.doj()).format('YYYY-MM-DD')
			}
			
			data.projects_map	= projects_map;
			data.projects_remove	= projects_remove;

			if (!data.password)
			{
				delete data.password;
				delete data.confirm_password;
			}

			return data;
		};

		_this.saveCallback	= function(item, self, clbk){
			var postData	= _this.prepareData(item);
			if (!postData)
				return false;

			Otime.app.postData(new Otime.ContextModel("save", postData, function(cont){
				var response	= cont.response;
				item.password('');
				item.confirm_password('');
				var isNew	= (item.user_id() <= 0);

				if (isNew == true)
				{
					item.user_id(response.items.user_id);
					if (response.items.user_image)
					{
						item.user_image(response.items.user_image);
						item.user_image_path(Otime.UMIP + response.items.user_image + "?time=" + new Date().getTime());
					}

					item._info.is_edit_permission(response.items.is_edit_permission);

					self && self.items && self.items.unshift(item);
				}
				item.commit();
				if (self)
				{
					self.is_comment_mode && self.is_comment_mode(false);
					self.swapMode && self.swapMode();
					_this.users_container.masonry('reload');
				}
				// reload common data
				Otime.Details.isInitialized = false;
				Otime.Details.init();
				clbk && typeof clbk == "function" && clbk(item);
				Otime.Menu.ReplaceURL(_this.name);
			}));
		};

		_this.UsersContentModel	= function(data, parent){
			var self	= this;

			data	= data || {};

			// self.parent = parent || {};
			self.departments= parent.departments;

			data.user_id	= (data.user_id || 0)-0;
			data.user_id && _this.ids.push(data.user_id);
			self.user_id			= Otime.o(data.user_id);
			self.first_name			= Otime.o(data.first_name || "").extend({required:true});
			self.first_name(self.first_name().charAt(0).toUpperCase() + self.first_name().slice(1));
			self.last_name			= Otime.o(data.last_name || "");
			self.email				= Otime.o(data.email || "").extend({required:true, email:true});
			
			if (data.dob) {
				data.dob =  Otime.stoj(data.dob);
			}
			if (data.doj) {
				data.doj =  Otime.stoj(data.doj);
			}
			self.dob				= Otime.o(data.dob || '');
			self.doj				= Otime.o(data.doj || new Date());
			self.password			= Otime.o("");
			self.confirm_password	= Otime.o("");
			self.time_zone_code		= Otime.o(data.time_zone_code || Otime.etzc);			
			self.user_image			= Otime.o(data.user_image || '');
			self.user_image_path	= Otime.o((data.user_image) ? Otime.UMIP + data.user_image :  Otime.baseUrl + '/files/photo/noImg.png');
			self.oldImage			= Otime.o((data.user_image) ? Otime.UMIP + data.user_image :  Otime.baseUrl + '/files/photo/noImg.png');
			self.hourly_rate		= Otime.o(data.hourly_rate || '');
			self.hourly_cost		= Otime.o(data.hourly_cost || '');
			self.hours				= Otime.o(data.hours-0);
			self.is_active			= Otime.o(data.is_active || 1);
			self.profile_image		= Otime.o();
			self.department = Otime.o(data.department || "");
			self.is_comment_mode	= Otime.o(false);
			self.edit_role_permission	= Otime.o(true);
			self.cropData	= Otime.o(null);

			self.rp	= Otime.o();
			
			self._info	= {};
			self._info.department = Otime.o("");
			self._info.char_length		= Otime.o(false);
			self._info.is_edit_password	= Otime.o(false);
			self._info.hasCaps	= Otime.o(false);
			self._info.hasSmall	= Otime.o(false);
			self.onPassFocus	= function(){
				$("#valid_popover").toggle();
			};
			self._info.hasNumber	= Otime.o(false);

			self.password.subscribe(function(newVal){
				self._info.char_length(newVal.length<9?false:true);
				self._info.hasCaps(newVal.match(/[A-Z]/) !== null);
				self._info.hasSmall(newVal.match(/[a-z]/) !== null);
				self._info.hasNumber(newVal.match(/[0-9]/) !== null || newVal.match(/[^\w]/) !== null);
			});

			var oldHourlyRate	= 0;
			var oldHourlyCost = 0;
			self.hourly_rate.subscribe(function(oldVal){
				oldHourlyRate	= oldVal;
			}, null, "beforeChange");
			self.hourly_rate.subscribe(function(newVal){
				$.each(self.projects(), function(key, val){
					(oldHourlyRate == val.hourly_rate() || !val.hourly_rate()) && val.hourly_rate((newVal-0)?newVal:self.hourly_cost());
				});
			});
			self.hourly_rate.subscribe(function(oldVal){
				oldHourlyCost	= oldVal;
			}, null, "beforeChange");
			self.hourly_cost.subscribe(function(newVal){
				if (!(self.hourly_rate()-0)) {
					$.each(self.projects(), function(key, val){
						(oldHourlyCost == val.hourly_rate() || !val.hourly_rate()) && val.hourly_rate(newVal);
					});
				}
			});
			self.select_all	= Otime.o(false);
			self.select_all.subscribe(function(newVal){
				$.each(self.projects(), function(key, val){
					val.is_assigned(newVal);
					newVal && val.hourly_rate((self.hourly_rate()-0)?self.hourly_rate():self.hourly_cost());
				});
			});
			self.projects	= Otime.a([]);

			self._project			=	{
				total_projects		: Otime.o(0),
				active_projects		: Otime.o(0),
				in_active_projects	: Otime.o(0),
				total_hours			: Otime.o(0),
				billable			: Otime.o(0),
				items				: Otime.a([]),
				view_more			: Otime.o(true),
				proj_page			: Otime.o(0),
				loading				: Otime.o(false)
			};

			self._info.is_edit_permission	= Otime.o(data.is_edit_permission || false),
			self._info.amount	= Otime.o(0);
			self._info.role_display	= Otime.o("");
			self._info.pagination	= {
				more: Otime.o(0)
			};
			self._info.is_ts_posted	= Otime.o(data.is_ts_posted || false);

			self.uploadDialog	= function(){
				$("#profile_image").trigger("click");
			};

			self.user_roles	= Otime.a([]);
			self.user_role	=	Otime.o("");
			self.role_disp	=	Otime.o("");
			// self.is_weekly_mail	= Otime.o(false);

			self.user_role.subscribe(function(newVal){
				self._info.role_display(Otime.Users.user_roles[newVal].role_value);

				var roles	= JSON.parse(JSON.stringify(Otime.Users.user_roles));
				var allowEdit	= true;
				allowEdit	= !(newVal == "A" || newVal == "M");

				delete roles["0"];

				if(newVal == "F")
				{
					delete roles["A"];
				}
				if(newVal == "P")
				{
					delete roles["A"];
					delete roles["F"];
				}

				var rolesObj	= [];
				$.each(roles, function(key, name){
					// rolesObj.push({"role_key":key, "role_value":name});
					rolesObj.push(name);
				});

				self.user_roles(rolesObj);

				$.each(self.projects(), function(key, val){
					val.user_role(newVal);
				});

//				if (newVal == "M")
//				{
//					// self.is_weekly_mail(false);
//				}
			});
			self.user_role(data.user_role || "M");

			if (data.info)
			{
				self._info.is_edit_permission(data.info.is_edit_permission || self._info.is_edit_permission());
				self._info.user_role(data.info.user_role || self._info.user_role());
				self._info.amount(data.info.amount || self._info.amount());
				self._info.pagination.more(data.info.pagination.more || self._info.pagination.more());
			}

			self.getParent	= function(){
				return parent;
			};

			self.save	= parent.save || null;
			self.cancel	= parent.cancel || null;
			//self.lock	= parent.lock || null;
			self.archiveItem = parent.archiveItem || null;
			self.deleteItem	= parent.deleteItem || null;
			self.reset	= parent.reset || null;
			self.cropApply		= parent.cropApply || null;
			self.show_activity	= parent.show_activity || null;
			self.removeImage	= parent.removeImage || null;
			self.load_more_projects	= parent.load_more_projects || null;
		};

		_this.ProjectItemModel = function(data, parent){
			var self = this;

			data = data || {};

			self.project_id		= Otime.o(data.project_id || 0);
			self.project_user_id		= Otime.o(data.project_user_id || 0);
			self.project_code	= Otime.o(data.project_code || "");
			self.project_name	= Otime.o(data.project_name || "");
			self.user_role		= Otime.o(data.user_role || "").extend({trackChange: true});
			self.role_display	= Otime.o(Otime.Users.user_roles[data.user_role].role_value || "");
			self.hourly_rate	= Otime.o(data.hourly_rate-0 || "").extend({trackChange: true});
//			self.estimated_hours	= Otime.o(data.estimated_hours-0 || "").extend({trackChange: true});
//			self.budget_type	= Otime.o(data.budget_type);
//			self.invoice_type	= Otime.o(data.invoice_type);
			self.is_assigned	= Otime.o(false).extend({trackChange: true});
			if (data.is_assigned) {
				self.is_assigned(data.is_assigned);
			}
			self.actual_hours	= Otime.o(data.actual_hours-0 || 0);

			self.is_assigned.subscribe(function(newVal){
				newVal && !self.hourly_rate() && self.hourly_rate(parent.hourly_rate());
			});

			self.edit_permission	= Otime.o(false);

			self.user_role.subscribe(function(newVal){
				self.role_display(Otime.Users.user_roles[newVal].role_value || "");
//				self.edit_permission(!(self.user_role() != '' && (self.user_role() == 'M' || self.user_role() == 'A')));
			});

			self.current_role	= Otime.a();
			self.isDirty	= Otime.c(function(){
				return (self.user_role.isDirty() || self.hourly_rate.isDirty() || self.is_assigned.isDirty());
			});
/*
			if (self.user_role() != '' && (self.user_role() == 'M' || self.user_role() == 'A'))
			{
				self.edit_permission(false);
//				self.current_role.push({role_id:self.user_role(), role_name:_this.roles[self.user_role()]});
			}
*/
		};

		_this.ProjectsInfoModel	= function(data){
			var self	= this;

			data	= data || {};
			data.date		= (data.date ? Otime.stoj(data.date) : "");
			self.project_id		= data.project_id;
			self.project_name	= data.project_name;
			self.client_name	= data.client_name;
			self.hours			= data.hours || 0;
			self.date			= Otime.o(data.date);
			self.display_dt	= Otime.o("");
			if(data.date != "")
			self.display_dt(new Date(self.date()).format(Otime.dateFormat || "MMM dd, yyyy"));

			self.is_active		= data.is_active;
		};

		_this.UpdateContainers	= function(){
			_this.users_container	= $("#users-container");

			_this.list_container	= $("#users-list-container");

			_this.edit_container	= $("#users-edit-container #edit_layout");

			_this.add_container		= $("#users-edit-container #edit_layout");

			_this.mainContainer	= $("#main-container");
		};

		_this.loadTemplates	= function(clbk){
			var url	= Otime.siteUrl + '/users/tmpl';
			Otime.loadTemplates(url, {
				v: Otime.version,
				r: Otime.usr
			}, function(content){
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			}, "users_" + Otime.version);
		};

		_this.init	= function(){
			_this.UpdateContainers();
			Otime.unbind();

			if (Otime.Users.user_roles)
			{
				var userRoles	= {};
				$.each(Otime.Users.user_roles, function(key, val){
					userRoles[key]	= {
						role_value: val,
						role_key: key
					};
				});
				Otime.Users.user_roles	= userRoles;
			}

			_this.user_id		= Otime.o("0");
			_this.fileApi	= new FileAPI({
				imageOnly: true
			});

			_this.users_container.masonry({ itemSelector: '.metro-item', columnWidth: 0 });
			_this.listModel	= new _this.UsersListModel();
			ko.applyBindings(_this.listModel, _this.users_container.get(0));

			_this.mainContainer.unbind("scroll");
			_this.mainContainer.scroll(function(){
				if($("#users-container").height() == ($(this).scrollTop()+$(this).height()-84))
				{
//					_this.listModel.finish(-1);
					_this.listModel.load_more();
//					_this.appModel.day_view().load_more();
					if (_this.listModel.finish() == true)
						_this.mainContainer.unbind("scroll");
				}
			});
		};
	};
}(window.Otime));
