var Service		= null;
var serviceName	= "OutputNotify";
var serviceDesc	= "Output time real time notification node app.";
var servicePath	= require("path").join(__dirname, "server.js");

// Copy the config.ini file.
var fs	= require('fs');
if (!fs.existsSync('config.ini')) {
	fs.createReadStream('config.org.ini').pipe(fs.createWriteStream('config.ini'));
}

if (process.platform == "win32")
{
	var node_windows = require('node-windows');
	node_windows.isAdminUser(function(isAdmin){
		if (isAdmin)
		{
			Service = node_windows.Service;
			installService();
		}
		else
		{
			console.log("Admin rights required to install the service.");
		}
	});
}
else if(process.platform == "linux")
{
	var node_linux = require('node-linux');
	Service = node_linux.Service;
	installService();
}
function installService()
{
	// Create a new service object
	var svc = new Service({
		name: serviceName,
		description: serviceDesc,
		script: servicePath
	});

	if ((typeof svc.exists == "function" && !svc.exists()) || !svc.exists)
	{
		svc.on("install", function(){
			console.log("Install complete.");
			svc.start();
		});

		svc.install();
	}
	else
	{
		svc.on("uninstall", function(){
			console.log("Uninstall complete.");
		});
		svc.start();
		svc.uninstall();
	}
}

