(function(OTWall){

	OTWall.Notification	= new function Notification(){
//		"use strict";

		var _this	= this;

		_this.name	= "notification";

		_this.model	= "NFListModel";

		_this.language	= null;
		
		_this.base_url = null;

		_this.current_view	= "";
		
		_this.module_actions 	= {'C':'commented on ', 'L':'liked ', 'A':' acknowledged ','OA':' posted a new announcement'};
		_this.module_types 		= {'C':'comment', 'O':'post','A':'Announcement'};
		_this.page 				= 0;

		_this.NFListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.isVisible = OTWall.o(false);
			self.items	= OTWall.a([]);
			self.pendingRequest = OTWall.o(false);
			var isScrollEnd	= false;

			/*
			// event:{scroll:scrolled}			
			self.scrolled = function(data, event) {
				var elem = event.target;
				if (!isScrollEnd && !self.pendingRequest() && elem.scrollTop > (elem.scrollHeight - elem.offsetHeight - 5))
				{
					self.getItems();
				}
			};
			*/
			self.scrolled = function(data, event) {
				if (!isScrollEnd && !self.pendingRequest()) {
					self.getItems();
				}
			};
			
			self.load_post	= function(item){
				if (item.post_id())
				{
					OTWall.Post.appModel.showPost(item.post_id());
				}
				return true;
			};

			self.getItems = function() {
				if (!_this.page)
				{
					self.items([]);
				}
				self.pendingRequest(true);
				$.get(OTWall.api_url+"notification/"+_this.page, function(resp){
					self.pendingRequest(false);
					if (!resp.items || !resp.items.length)
					{
						isScrollEnd	= true;
						return false;
					}

					isScrollEnd	= false;
					var tmpList	= [];
					var nf_ids 	= [];
					
					$.each(resp.items, function(key, val){
						tmpList.push(new _this.NFContentModel(val));
						if (!(val.is_read-0) && val.user_id)
							nf_ids.push(val.notification_id);
					});
					user_notification_count = 0;
					$('#notification .user-notify-cnt').hide();
					
					if (nf_ids.length) {
						user_notification_count -= nf_ids.length;
						if (user_notification_count<=0) {
							user_notification_count = 0;
							$('#notification .user-notify-cnt').hide();
						} else {
							$('#notification .user-notify-cnt').show();
						}
						
						$.post(OTWall.api_url+"notification_update", {ids:nf_ids}, function(resp){
							// return true;
						});
					}

					if (tmpList)
					{
						self.items.append(tmpList);
					}

					if (!_this.page)
						_this.container.show();

					_this.page++;

					return;
				});	
			}
		};

		_this.NFContentModel	= function(data){
			var self	= this;

			data	= data || {};

			self.id			= OTWall.o(data.notification_id-0 || 0);
			self.notes		= OTWall.o(data.notes || "");
			self.is_read		= OTWall.o(data.is_read-0 || 0);
			self.post_id		= OTWall.o(data.post_id-0 || 0);
			self.module_type	= OTWall.o(data.module_type || '');
			self.date		= new Date(data.posted_on*1000);
			/*self.id				= OTWall.o(data.notification_id-0 || 0);
			self.notes			= OTWall.o(data.notes || "");
			self.is_read		= OTWall.o(data.is_read-0 || 0);
			self.post_id		= OTWall.o(data.post_id-0 || 0);*/
			data.post_user		= 0;
			if (data.post_by) {
				var post_by		= data.post_by;
				data.post_by 	= data.post_by.replace(/\d+#/g,'');
				data.post_by 	= data.post_by.replace(/(^,)|(,$)/g, "");
				if (data.post_by) {
					data.post_user = post_by.match(/\d+#/)[0].replace('#','');
					data.post_count = data.post_by.split(',').length-1;
				}
			}

			var usr	= OTWall.Users.user_list_by_id[data.post_user];
			self._info	= {
				user_image: "",
				user_name: ""
			};
			if (usr) {
				self._info.user_image = usr.img;
				self._info.user_name = usr.name;
			}
			self.post_by		= OTWall.o(data.post_by || '');
			self.post_count		= OTWall.o(data.post_count || 0);
			self.nfy_msg		= OTWall.o('');
			
			data.created_by =  data.created_by-0 || 0;

			if (data.module_action) {
				var pre_text = self.post_by().split(',').join(', ');
				var usr_cnt = 0;
				if (data.post_count>1) {
					var nm_cnt = data.post_count<=2?data.post_count:1;
					nm_cnt++;
					pre_text = 	self.post_by().split(',',nm_cnt).join(', ');
					nm_cnt--;
					usr_cnt = self.post_count()-nm_cnt;
				}
				pre_text = '<strong>'+pre_text+'</strong>';
				if (usr_cnt) {
						pre_text +=  ' and <strong>'+usr_cnt+((usr_cnt>1)?' others':' other')+'</strong> also';
				}
				pre_text+=' '+_this.module_actions[data.module_action];
				
				if (data.module_action!='OA') {
					var created_by = data.created_by==OTWall.user_id?' your ':'';
					if (!created_by && OTWall.Users.user_list_by_id[data.created_by]) {
						created_by = ' <strong>'+OTWall.Users.user_list_by_id[data.created_by].name+'</strong> ';
					}
				
					pre_text+=created_by+_this.module_types[data.module_type];
				}
				self.nfy_msg(pre_text+(data.subject?('<div class="dark_text">'+(data.subject.length>50?data.subject.substring(0,50)+'..':data.subject)+'</div>'):''));
			}
		};

		_this.model	= OTWall.o(null);

		_this.init	= function(isLoadItems){
			_this.container	= $("#notification-container");

			if (_this.container.is(":visible"))
			{
				_this.model().isVisible(false);
				_this.container.hide();
				_this.page = 0;
			}
			else if(_this.container.get(0))
			{
				if (ko.dataFor(_this.container.get(0)) == undefined)
				{
					_this.model(new _this.NFListModel());
					//	ko.applyBindings(_this.model, _this.container.get(0));
				}
				_this.model().isVisible(true);
				isLoadItems && _this.model().getItems();

				setTimeout(function(){
					$(document).one("click", function(e){
						if (_this.container.is(":visible") && !$(e.target).hasClass('mCSB_dragger_bar')) {
							_this.model().isVisible(false);
							_this.container.hide();
							_this.page = 0;
						}
					});
				}, 500);
			}

			return _this.model;
		};
	};
}(window.OTWall));
