(function (OTWall) {
	OTWall.Post = new function Post() {
		var _this = this;
		_this.url = 'list/all';
		_this.new_post_id = 0;

		_this.ImageSizes	= {
			small: '114',
			medium: '246',
			big: '940'
			//big: '470'
		};

		var postContainer = null;

		var setMasonry = function (isReload) {
			if (_this.appModel.is_list_view()) {
				return;
			}

			var elem = $("#listing");
			if (isReload && elem.data("masonry")) {
				setTimeout(function () {
					elem.masonry("reload");
				}, 500);
			}
			else {
				setTimeout(function () {
					elem.masonry({
						itemSelector: '.post.media',
						columnWidth: 307,
						isFitWidth: true
					});
				}, 500);
			}
			elem.imagesLoaded(function () {
				elem.data("masonry") && elem.masonry("reload");
			});
		};

		var POST_TYPES = {
			MESSAGE: "M",
			ANNONCEMENT: "A",
			POLL: "P",
			AWARD: "W"
		};
		var award_types = {
			crown: { award_type: "crown", className: "crown", text: "Crown" },
			medal: { award_type: "medal", className: "medal", text: "Medal" },
			award: { award_type: "award", className: "award", text: "Award" },
			heart: { award_type: "heart", className: "heart", text: "Heart" },
			cake: { award_type: "cake", className: "cake", text: "Cake" },
			star: { award_type: "star", className: "star", text: "Star" },
			gift: { award_type: "gift", className: "gift", text: "Gift" },
			idea: { award_type: "idea", className: "idea", text: "Idea" },
			graduation: { award_type: "graduation", className: "graduation", text: "Graduation" },
			diamond: { award_type: "diamond", className: "diamond", text: "Diamond" }
		};

		var user_notification_count = 0;

		// var last_viewed_post = OTWall.Storage.get("last_viewed_post", "");

		_this.ListModel = function (data) {
			var self = this;

			var users = OTWall.Users.user_list.filter(function(item){
				return item.user_id != OTWall.user_id;
			});

			self.users_list = OTWall.a(users);
			self.logged_user = OTWall.Users.user_list_by_id[OTWall.user_id];

			self.listing = OTWall.a([]);
			self.listingById = OTWall.a([]);
			self.no_post = OTWall.o(false);
			self.is_list_view = OTWall.o(!!(OTWall.Storage.get("is_list_view", "1") - 0));

			self.refreshGrid = setMasonry;
			self.is_list_view.subscribe(function (newVal) {
				if (!newVal) {
					setTimeout(function () {
						setMasonry();
					}, 800);
				}
			});
			OTWall.post_id - 0 && !self.is_list_view() && self.is_list_view(true);

			self.notification = OTWall.Notification.init();

			self.swap_view = function () {
				self.is_list_view(!self.is_list_view());
				OTWall.Storage.set("is_list_view", self.is_list_view() ? "1" : "0");
			};

			self.swap_menu = function () {
				postContainer.toggleClass("menu-open");
			};

			self.swap_window = function () {				
				try {
					if ((OTWall.new_window()-0))
						self.is_list_view(true);
					OTWall.new_window((OTWall.new_window()-0)?0:1);
					window.parent && window.parent.postMessage({type:'togglewindow', arg1:OTWall.new_window()},'*');
					window.external && window.external.togglewindow(OTWall.new_window());
				} catch(Ex){
					// Ex
				}				
			}

			self.selectedItem 		= OTWall.o(null);
			self.selectedTmpitem	= OTWall.o(null);

			self.list_after_render = function () {
				if (self.listing().length) {
					$('.post_msg').css('white-space', 'pre-wrap');
					self.no_post(false);
				}
			};

			self.listing.subscribe(function () {
				if (!self.listing().length) {
					self.no_post(true);
				}
			});

			self.trends = OTWall.a([]);
			self.menus = OTWall.a([]);
			self.group_users = OTWall.a([]);

			self.reset_users = function() {
				var tmp_users = [];
				$.each(OTWall.Users.user_list, function (key, val) {
					if (val['is_active'])
						tmp_users.push(val);
				});
				self.group_users(tmp_users);
			}
			self.reset_users();
			
			self.menuById = {};
			var menus = [{
				title: 'MENU',
				sorting: 0,
				child: OTWall.a(),
				default_child: OTWall.a([])
			}];
			var child = [
				{ name: 'My Wall', value: 'all', bg_color: '', class_name: 'icon icon-home gray', count: OTWall.o(0), type:'post' },
				//{name:'Office Wall', value:'office', class_name:'icon icon-building gray'},
				{ name: 'Announcements', value: 'announcement', bg_color: '', class_name: 'icon icon-bullhorn gray', count: OTWall.o(0), type:'announcement' },
				{ name: 'Polls', value: 'poll', bg_color: '', class_name: 'icon icon-align-left gray', count: OTWall.o(0), type:'poll' },
				{ name: 'Favorites', value: 'favorite', bg_color: '', class_name: 'icon icon-star gray', count: OTWall.o(0), type:'favorite' }
			];
			$.each(child, function (key, val) {
				self.menuById[val.value] = val;
				menus[0].child.push(val);
			});
			child = [];
			if (OTWall.Users.groups && OTWall.Users.groups.length) {
				var tmp = { title: 'WALL', sorting: 1, child: OTWall.a([]), default_child: OTWall.a([]) };
				var group_order = OTWall.Storage.get('group_order');
				if (group_order) {
					group_order = group_order.split(',');
					$.each(OTWall.Users.groups[0].items, function (key, val) {
						var g_index = group_order.indexOf(val.group_id);
						if (g_index == -1) {
							g_index = group_order.length;
							g_index = tmp.child().length < g_index ? g_index : tmp.child().length;
						}

						val.bg_color = val.bg_color ? 'color:' + val.bg_color : '';
						child[g_index] = {
							name: val.name,
							value: val.group_id,
							bg_color: val.bg_color,
							class_name: 'icon icon-circle-blank',
							type: 'group',
							count: OTWall.o(0),
							group_type: OTWall.Users.groups[0].type
						};
					});
				}
				else {
					$.each(OTWall.Users.groups[0].items, function (key, val) {
						val.group_type = OTWall.Users.groups[0].type;
						val.bg_color = val.bg_color ? 'color:' + val.bg_color : '';
						child.push({
							name: val.name,
							value: val.group_id,
							bg_color: val.bg_color,
							class_name: 'icon icon-circle-blank',
							type: 'group',
							count: OTWall.o(0),
							group_type: OTWall.Users.groups[0].type
						});
					});
				}
				var office = {
					name: 'Office wall',
					value: 'office',
					class_name: 'icon icon-building gray',
					bg_color: '',
					type:'post',
					normal: false,
					count: OTWall.o(0)
				};
				tmp.child().push(office);
				self.menuById[office.value] = office;
				$.each(child, function (key, val) {
					if (val) {
						val.normal = true;
						self.menuById[val.value] = val;
						tmp.child.push(val);
					}
				});

				menus.push(tmp);
			} else {
				menus.push([]);
			}
			menus.push({ trends: self.trends });
			self.menus(menus);

			self.awards = OTWall.a(Object.values(award_types));

			self.new_message = OTWall.o(new _this.MessageModel({
				post_type: "M",
				award_type: self.awards()[0]
			}));
			self.hide_new = OTWall.o(false);
			self.new_post_tmpl = OTWall.o("new-post-tmpl");
			var subject_autofocus = function() {
				setTimeout(function() {$('#post_subject').focus();}, 500);
			} 
			self.show_message = function (item) {
				self.new_post_tmpl("new-post-tmpl");
				item.post_type("M");
				subject_autofocus();
			};

			self.show_poll = function (item) {
				self.new_post_tmpl("new-post-tmpl");
				item.post_type("P");
				subject_autofocus();
			};

			self.show_announcement = function (item) {
				self.new_post_tmpl("new-post-tmpl");
				item.post_type("A");
				subject_autofocus();
			};

			self.show_awards = function (item) {
				self.new_post_tmpl("new-post-award-tmpl");
				item.post_type("W");
				subject_autofocus();
			};
			

			self.addNew = function () { };

			self.edit = function () { };

			self.delete_item = function (item) {
				if (confirm('Are you sure to delete this entry?')) {
					$.post(OTWall.api_url + "delete", {
						post_id: item.post_id
					}, function (resp) {
						if (resp.data) {
							self.listing.remove(item);
							setMasonry(true);
							$("#img-preview").modal("hide");
							self.selectedItem(null);
						}
					});
				}
			};

			self.favorite = function (item) {
				$.post(OTWall.api_url + (item.is_favorite() ? "unfavorite" : "favorite"), {
					post_id: item.post_id
				}, function (resp) {
					if (resp.data) {
						item.is_favorite(!item.is_favorite());
					}
				});
			};

			self.follow = function (item) {
				$.post(OTWall.api_url + (item.is_follow() ? "unfollow" : "follow"), {
					post_id: item.post_id
				}, function (resp) {
					if (resp.data) {
						item.is_follow(!item.is_follow());
					}
				});
			};

			self.like = function (item) {

				var tmp_liked = item.liked + "";
				tmp_liked = tmp_liked.split(',');
				if (!item.is_liked()) {
					tmp_liked.push(OTWall.user_id);
					item.like_count((item.like_count()-0) + 1);
					item.is_liked(true);
					$.post(OTWall.api_url + "like", { post_id: item.post_id }).fail(function (resp) {
						tmp_liked.unset(OTWall.user_id+ "");
						item.like_count((item.like_count()-0) - 1);
						item.is_liked(false);
					});
				}
				else {
					item.like_count((item.like_count()-0) - 1);
					item.is_liked(false);
					tmp_liked.unset(OTWall.user_id + "");
					$.post(OTWall.api_url + "unlike", { post_id: item.post_id }).fail(function (resp) {
							item.like_count((item.like_count()-0) + 1);
							tmp_liked.push(OTWall.user_id);
							item.is_liked(true);
					});
				}
				item.liked = tmp_liked.join(',');
				buildLikedList(item);
			};

			self.acknowledge = function (item) {
				if (!item.is_acknowledge()) {
					var tmp_ack = item.ack + "";
					tmp_ack = tmp_ack.split(',');
					tmp_ack.push(OTWall.user_id);

					item.ack_count((item.ack_count()-0) + 1);
					item.is_follow(true);
					item.is_acknowledge(true);

					$.post(OTWall.api_url + "acknowledge", { post_id: item.post_id }).fail(function (resp) {
						tmp_ack.unset(OTWall.user_id+ "");
						item.ack_count((item.ack_count()-0) -1);
						item.is_follow(false);
						item.is_acknowledge(false);
					});
					item.ack = tmp_ack.join(',');
					buildLikedList(item);
				}
			};

			self.addComment = function (item, elem) {
				if (!item.is_new_comments) {
					return false;
				}
				item.is_new_comments(!item.is_new_comments());
				var parent = $(elem.target).parents(".post.media");
				$("textarea.commentContent", parent).focus();

				if (item.is_new_comments().length > 10)
					parent.get(0).scrollIntoView(false);
			};

			/*self.showLikedUsers = function (item, e) {
				if (!item.liked || item.liked.length < 1) {
					$(".popover.in").removeClass("in").hide();
					return false;
				}

				var parent = $(e.delegateTarget).parent();
				var elem = $(".popover", parent);
				var isVisible = elem.is(".in");

				$(".popover.in").removeClass("in").hide();

				!isVisible && elem.css({
					top: -((elem.height() / 2) - 8)
				}).show().toggleClass("in");

				/*var popOver = $(".popover.in").get(0);
				parent = parent.get(0);
				var backdropClick = function (e) {
					// if (!popOver.contains(e.target))
					if (!parent.contains(e.target)) {
						$(".popover.in").removeClass("in").hide();
						$(document).unbind("mousedown", backdropClick);
						return false;
					}
				};
				$(document).mousedown(backdropClick);
			};*/

			self.load_more_comments = function (item) {
				if (item.isCmtLoadMore() && item.comments().length) {
					$.get(OTWall.api_url + "comments/" + item.post_id + "/" + item.comments()[0].comment_id, function (resp) {
						if (resp.data && resp.data.comments && resp.data.comments.length > 0) {
							var commentsByPostId = buildCommentsList(resp.data.comments);
							item.comments.prepend(commentsByPostId[item.post_id]);
							if (resp.data.comments.length < 10)
								item.isCmtLoadMore(false);
						}
						else {
							item.isCmtLoadMore(false);
						}
					});
				}
			};

			self.activeMenu = OTWall.o(self.menus()[0].child()[0]);
			self.showHome = function () {
				self.user_profile(null);
				self.is_home(true);
				self.showMenu(self.menus()[0].child()[0]);
			};
			self.showMenu = function (item, elem) {
				self.activeMenu(item);
				self.search_input('');
				self.user_profile(null);
				self.is_home(true);
				/*
								$(".list-group-item").removeClass("active");
								var target = elem.currentTarget;
								if ($(target).hasClass('list-group-item'))
									$(target).addClass("active");
								else
									$(target).parent().addClass("active");
				*/

				if (_this.appModel.menuById[item.value]) {
					_this.appModel.menuById[item.value].count(0);
					self.reset_count();
				}
				/*var elem = $(".right-pane .wall_" + item.value);
				elem.text('');*/
				new_post = 0;
				$('#new_notification').hide();
				if (item.type && item.type == 'group') {
					var newMsg = self.new_message();
					newMsg.post_to(item.group_type + "_" + item.value);
					self.new_message(newMsg);
					self.reset_count();
					item.post_to = item.value;
					self.showGroup(item);
					self.is_home(false);
				}
				else {
					var newMsg = self.new_message();
					newMsg.post_to("all");
					self.new_message(newMsg);
					self.reset_count();
					self.is_home(item.value != 'all' ? false : true);
					_this.loadDataAjax(self, "list/" + item.value);
				}
			};

			self.reset_count = function () {
				var unread = 0;
				$.each(_this.appModel.menuById, function (key, val) {
					if (!isNaN(key) || key == 'office')
						unread += (val.count() - 0);
				});
				_this.appModel.menuById['all'].count(unread);
			};

			self.sortMenu = function (group) {
				var tmp = [];
				$.each(group.sourceParent(), function (key, val) {
					tmp.push(val.value);
				});
				OTWall.Storage.set('group_order', tmp);
			};

			self.showTag = function(item, elem) {
				self.search_input('');
				self.activeMenu(item);
				self.is_home(false);
				_this.loadDataAjax(self, "hashtag/" + item.name.replace('#', ''));
			};

			var onSelectAwards = function(award_type){
				// Update the list with 'award_type' filter.
				console.log("onSelectAwards award_type : ", award_type);
				var profile_item = self.user_profile();
				_this.loadDataAjax(self, "award/" + award_type + "/" + profile_item.user_id);
			};

			self.showUser = function (item, elem) {
				self.search_input('');
				$("#img-preview").modal("hide");

				var profile_item = null;
				profile_item = OTWall.Users.user_list_by_id[elem.delegateTarget.id];
				profile_item.awards = [];
				if (!profile_item.selectAwards) {
					profile_item.selectAwards = onSelectAwards;
				}
				self.user_profile(profile_item);
				_this.loadDataAjax(self, "user/" +elem.delegateTarget.id);
			};

			self.showGroup = function (item) {
				self.search_input('');
				_this.loadDataAjax(self, "group/" + item.post_to);
			};

			self.showPost = function (post_id) {
				if (!post_id) {
					return;
				}

				self.user_profile(null);
				self.is_home(false);
				_this.loadDataAjax(self, "post/" + post_id);
				self.is_list_view(true);
			};

			self.user_profile = OTWall.o(null);
			self.is_home = OTWall.o(true);
			self.show_user = function (item) {
				$("#img-preview").modal("hide");

				var profile_item = null;
				if (item.img && item.name) {
					profile_item = item;
				}
				else {
					profile_item = item._info.user;
				}
				profile_item.awards = [];

				if (!profile_item.selectAwards) {
					profile_item.selectAwards = onSelectAwards;
				}

				self.user_profile(profile_item);
				self.is_home(false);
				_this.loadDataAjax(self, "user/" + profile_item.user_id);
			};

			self.search_input = OTWall.o('');
			self.isSearch = OTWall.o(false);
			self.search = function(){
				var str = self.search_input().trim();
				if (!str)
					return;

				self.isSearch(true);

				self.activeMenu(self.menus()[0].child()[0]);

				// _this.loadDataAjax(self, "hashtag/" + str);
				var trends = str.match(/\B#([\-+\w]*)$/);
				var url_src = "search/" + escape((trends && trends[1])?trends[1]:str);
				_this.loadDataAjax(self, url_src);
				postContainer.get(0).scrollTop = 0;
			}
			self.clearSearch = function(){
				self.isSearch(false);
				self.showHome();
				self.search_input("");
			};
			self.showNew = function (item) {
				var hold_reset = item.hold_reset || 0;
				var tmp = _this.url.split('/');
				var len = tmp.length - 1;
				if (_this.new_post_id) {
					$.post(OTWall.api_url + "newlist", { id: tmp[len], type: tmp[--len], new_post_id: _this.new_post_id }, function (resp) {
						if (!resp.data || !resp.data.posts) {
							return false;
						}
						new_post = 0;
						_this.new_post_id = 0;
						_this.loadData(resp.data, self, false);
						if (!hold_reset)	{
							OTWall.PostNotify(0);
						}
						$('#new_notification').hide();
						$("html, body").animate({ scrollTop: 0 }, "slow");
					});
				}
			}

			self.pollSubmit = function (item) {
				return function (form) {
					$.post(OTWall.api_url + "poll_vote", $(form).serializeArray(), function (resp) {
						if (resp && resp.data && resp.data.post_input) {
							item.post_input = resp.data.post_input;
							item.is_voted(true);
							setMasonry(true);
						}
					});
				}
			};

			var enableBtn = function (element) {
				element.value = "Post";
				element.removeAttribute("disabled");
			};
			self.save_post = function (item, elem) {
				var element = elem.delegateTarget;
				element.setAttribute("disabled", "disabled");
				element.value = "Posting";

				var postData = {
					post_subject: item.post_subject() || "",
					post_message: item.post_message() || "",
					post_type: item.post_type()
				};

				// Award
				if (item.post_type() == POST_TYPES.AWARD) {
					postData.award_type = item.award_type().award_type;
					postData.award_users = item.award_users();
					if (!postData.award_users.length) {
						alert("Atleast one recipient need to be selected.")
						return false;
					}
				}
				else if (item.is_poll()) {
					postData.answers = [];
					var removeItem = [];
					$.each(item.answers(), function (key, val) {
						if (!val.answer()) {
							removeItem.push(val);
							return true;
						}
						postData.answers.push({
							id: postData.answers.length + 1,
							answer: val.answer()
						});
					});

					$.each(removeItem, function (key, val) {
						item.answers.remove(val);
					});

					if (item.answers().length < 2) {
						alert("Atleast 2 answers need for polling post.");
						return false;
					}

					// postData.question	= item.question();
					postData.multiple_choice = item.multiple_choice() ? 1 : 0;
					postData.result_after_vote = item.result_after_vote() ? 1 : 0;
					postData.hide_identity = item.hide_identity() ? 1 : 0;
				}
				
				if (item.is_announcement()) {
					postData.ack_required = item.ack_required() ? 1 : 0;
				}

				//				var postData	= $(".tab-pane.active form").serializeArray();
				if (item.post_to()) {
					var postTo = {},
						tmpVal = item.post_to().split("_");
					/*if (!postTo[tmpVal[0]])
					{
						postTo[tmpVal[0]]	= [];
					}*/
					if (tmpVal[1])
						postTo[tmpVal[0]] = tmpVal[1];
					/*
										var postTo	= {}, tmpVal;
										$.each(item.post_to(), function(key, val){
											tmpVal	= val.split("_");
											if (!postTo[tmpVal[0]])
											{
												postTo[tmpVal[0]]	= [];
											}
											postTo[tmpVal[0]].push(tmpVal[1]);
										});
										postData.post_to	= postTo;
					*/
					postData.post_to = Object.keys(postTo).length ? postTo : '';
					// postData.post_to	= item.post_to();
				}

				var linkify = function(text) {
					var urlRegex =/(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/ig;
					return text.replace(urlRegex, function(url) {
						return '<a target="_blank" href="' + url + '">' + url + '</a>';
					});
				}

				var save = function(){
					postData.post_subject = postData.post_subject.trim();

					if (postData.post_message)
					{
						// Replace the Emoji Images into Emoji notations.
						postData.post_message = postData.post_message.replace(/<img.*?txt="(.*?)".*?>/g, ' :$1: ');

						// Replace the Html P tag's, br tag's with \n.
						postData.post_message = postData.post_message.replace(/<\/p>/gi, "\n").replace(/<br\/?>/gi, "").replace(/<\/?[^>]+(>|$)/g, "");
						postData.post_message = postData.post_message.replace(/\&nbsp\;/gi, ' ');
						postData.post_message = postData.post_message.trim();
						postData.post_message = linkify(postData.post_message);
					}

					// check have message or attachments before save
					if (!postData.post_subject && !postData.post_message && !postData.attachments) {
						enableBtn(element);
						// alert("Message or Attachment is required.");
						return;
					}

					$.post(OTWall.api_url + "post_save", postData, function (resp) {
						//	_this.Trends(); load if new trends in posttrends
						if (resp) {
							var posts_attachments = buildAttachmentList(resp.data.attachments);
							var val = resp.data.post;

							if (posts_attachments[val.post_id]) {
								val.attachments = posts_attachments[val.post_id];
							}
							_this.ContentModel(val, self);
							self.listingById[val.post_id] = val;
							self.listing.prepend([val]);

							setMasonry(true);

							self.cancel_post(item);	// Reset the form.
							enableBtn(element);
							return false;
						}
					});
				};

				var queueLength	= item.fileList.length;
				if (queueLength)
				{
					var i = 0;
					var arrAttachDetails = [];
					$.each(item.fileList, function(key, val){
						val.submit.call(val).done(function(resp, data){
							if (data == "success" && resp)
							{
								if (!resp[0]) {
									alert(resp[1].replace(/<(?:.|\n)*?>/gm, ''));
									return false;
								} else if (resp[2]) {
									var fileSize = val.files[0].size;
									var filename = val.files[0].name;
									var files = filename.match(/([^.]+)/g);
									var file_type = files.pop();
									var file_name = files.join(".");

									arrAttachDetails.push({
										file_type: file_type,
										file_name: file_name,
										file_size: fileSize,
										tmp_key: resp[2].file_name
									});

									i++;
									if (i == queueLength) {
										postData.attachments = arrAttachDetails;
										item.fileList	= [];
										save();
									}
								}
							}
						});
					});
					return false;
				}

				save();
				return false;
			};

			self.cancel_post = function (item) {
				var post_type = "M"; 
				if (item && item.post_type()) {
					post_type = item.post_type();
				}
				var item = self.new_message();
				self.new_message(new _this.MessageModel({
					post_type: post_type,
					award_type: self.awards()[0]
				}));

				/*
								switch(item.post_type())
								{
									case 'M':
										self.new_message(new _this.MessageModel({post_type:"M"}));
									break;
									case 'P':
										self.new_poll(new _this.MessageModel({post_type:"P"}));
									break;
									case 'A':
										self.new_annoncement(new _this.MessageModel({post_type:"A"}));
									break;
								}
				*/
			};

			self.postNewComment = function (post) {
				if (!post || !post.newCommentMsg()) {
					return false;
				}

				var postData = {
					comment_id: 0,
					message: post.newCommentMsg(),
					module_id: post.post_id,
					module_type: "O"
				};

				postData.message = postData.message.trim();
				if (!postData.message) {
					post.newCommentMsg("");
					return false;
				}

				$.post(OTWall.api_url + "comment_save", postData, function (resp) {
					if (!resp || !resp.data) {
						return false;
					}
					postData.comment_id = resp.data.comment_id;
					postData.created_by = resp.data.created_by - 0;
					postData.created_date = new Date((resp.data.created_date - 0) * 1000);

					commentItemDetails(postData);

					post.comments.push(postData);
					post.comments_count((post.comments_count() - 0) + 1);
					post.newCommentMsg("");
					post.is_follow(true);
				});
			};

			self.isTabHidden = OTWall.o(false);

			OTWall.onTabChange(function (isHidden) {
				self.isTabHidden(isHidden);
			});

			var isRefreshing = false;
			self.refresh = function () {
				if (isRefreshing || self.isTabHidden()) {
					return true;
				}
				isRefreshing = true;

				// call get list
				// in response
				// isRefreshing	= false;
			};
			/*
						// Refresh every 1min.
						setInterval(function(){
							self.refresh();
						}, 6E4);
			*/
		};

		var buildAttachmentList = function (attachments) {
			var posts_attachments = {};

			if (attachments && attachments.length > 0) {
				$.each(attachments, function (key, val) {

					if (!posts_attachments[val.module_id])
						posts_attachments[val.module_id] = [];

					val.path = OTWall.api_url + 'attachment/';
					val.download_url = "";
					val.is_image = true;

					if ((["bmp", "jpg", "jpeg", "png", "svg", "gif"]).indexOf(val.file_type.toLowerCase()) < 0)
					{
						val.is_image = false;
						val.download_url	= OTWall.api_url + 'download/' + val.encrypt_key;
						val.image_src = val.path + val.encrypt_key;

//						val.path	= 'assets/img';	// need to change to attachment type (pdf, doc, text file, etc...) image location.
//						val.image_src	= val.path + '/' + val.file_path;
					}
					else
					{
						val.image_src	= OTWall.attachUrl + _this.ImageSizes.big + '/' + val.file_path;
						val.image_src_s	= OTWall.attachUrl + _this.ImageSizes.small + '/' + val.file_path;
						val.image_src_m	= OTWall.attachUrl + _this.ImageSizes.medium + '/' + val.file_path;
						// val.image_src = val.path + val.encrypt_key;
					}

					val.file_full_name = val.file_name + "." + val.file_type;

					posts_attachments[val.module_id].push(val);
				});
			}

			return posts_attachments;
		};
		var buildLikedList = function (item) {

			if (!item._info.ack_users_name){
				item._info.ack_users_name = OTWall.o();
				item._info.ack_users = OTWall.a();
			}

			if (item.ack) {
				var tmp_ack = item.ack.split(",").reverse();
				var ack_users = [];
				var ack_users_name = [];
				for (var i=0, iLen=tmp_ack.length; i<iLen; i++)
				{
					if (OTWall.Users.user_list_by_id[tmp_ack[i]])
					{
						ack_users_name.push(OTWall.Users.user_list_by_id[tmp_ack[i]].name); 
						ack_users.push(OTWall.Users.user_list_by_id[tmp_ack[i]])
					}
				}
				item._info.ack_users_name(ack_users_name.join(','));
				item._info.ack_users(ack_users);
			}

			if (!item._info.liked_users_name){
				item._info.liked_users_name = OTWall.o();
				item._info.liked_users = OTWall.a();
			}
			if (item.liked) {
				item.liked = item.liked.split(",").reverse();
				var liked_users = [];
				var liked_users_name = [];
				for (var i=0, iLen=item.liked.length; i<iLen; i++)
				{
					if (OTWall.Users.user_list_by_id[item.liked[i]])
					{
						liked_users_name.push(OTWall.Users.user_list_by_id[item.liked[i]].name); 
						liked_users.push(OTWall.Users.user_list_by_id[item.liked[i]])
					}
				}
				item._info.liked_users_name(liked_users_name.join(','));
				item._info.liked_users(liked_users);
			}
		};
		var commentItemDetails = function (item) {
			item._info = {
				liked_users:OTWall.a([])
			};
			item.usersListType = item.usersListType || OTWall.o('liked_users');
			
			item.like_count = OTWall.o(item.like_count - 0 || "");
			item.is_liked = OTWall.o(!!(item.is_liked - 0));
			var usr = OTWall.Users.user_list_by_id[item.created_by];
			item.show_delete = OTWall.o(false);
			
			if (OTWall.user_id==item.created_by) {
					item.show_delete(true);
			} else if (OTWall.Users.user_list_by_id[OTWall.user_id].user_role=='A'){
				item.show_delete(true);
			} else if(OTWall.Users.user_list_by_id[OTWall.user_id].user_role=='M' && usr.user_role!='A' && usr.user_role!=OTWall.Users.user_list_by_id[OTWall.user_id].user_role) {
				item.show_delete(true);
			}

			//			item.created_by	= OTWall.o(item.created_by);
			buildLikedList(item);

			
			if (usr) {
				item._info.user = usr;
			}
			item.created_date = new Date((item.created_date - 0) * 1000);
		};
		var buildCommentsList = function (comments) {
			var commentsByPostId = {};
			if (comments && comments.length > 0) {
				var usr = "";
				var tmp_comments = comments.reverse();
				$.each(tmp_comments, function (key, val) {
					if (!commentsByPostId[val.module_id])
						commentsByPostId[val.module_id] = [];
					commentItemDetails(val);
					commentsByPostId[val.module_id].push(val);
				});
			}
			return commentsByPostId;
		};

		_this.loadData = function (data, self, is_append) {
			var posts_attachments = buildAttachmentList(data.posts_attachments);
			var commentsByPostId = buildCommentsList(data.comments);
			/*
						// Users list update based on Group Selected.
						if (data.project_users)
						{
							var users	= [];
							$.each(data.project_users, function(key, user_id){
								OTWall.Users.user_list_by_id[user_id] && users.push(OTWall.Users.user_list_by_id[user_id]);
							});
			
							self.users_list(users);
						}
						else
						{
							self.users_list(OTWall.Users.user_list);
						}
			*/

			if (data.award) {
				var prof = self.user_profile();
				prof.awards = [];
				var tmp;
				$.each(data.award, function (key, val) {
					tmp = award_types[val.type];
					tmp.count = val.count;
					prof.awards.push(tmp);
				});
				self.user_profile(prof);
			}
			if (data.posts && data.posts.length > 0) {
				// self.no_post(false);
				var usr = "";
				$.each(data.posts, function (key, val) {
					/*if (last_viewed_post<val.post_id) {
						last_viewed_post = val.post_id;
						OTWall.Storage.set("last_viewed_post", last_viewed_post);
					}*/

					if (posts_attachments[val.post_id]) {
						val.attachments = posts_attachments[val.post_id];
					}

					if (commentsByPostId[val.post_id]) {
						val.comments = commentsByPostId[val.post_id];
					}
					val.is_newpost = (is_append == undefined || is_append) ? 0 : 1;
					var wall_type = val.post_to ? val.post_to : 'office';

					// if (self.menuById[wall_type].count()-0)
					// {
					// self.menuById[wall_type].count(self.menuById[wall_type].count()-1);
					// self.reset_count();
					// }
					_this.ContentModel(val, self);
					self.listingById[val.post_id] = val;
				});

				self.listing[is_append ? "append" : "prepend"](data.posts);
				if (OTWall.post_id - 0) {
					OTWall.post_id = 0;
					$.each(data.posts[0].attachments(), function (key, attach) {
						if (attach.is_image) {
							data.posts[0].currentImg(attach);
							return false;
						}
					});
					self.selectedItem(data.posts[0]);
				}
			} else {
				self.no_post(true);
			}
			// setTimeout(function(){
			setMasonry(true);
			$(window).scrollTop($(window).scrollTop() + 1);
			// }, 300);
		};

		_this.loadComment = function (item, comment_id) {
			$.get(OTWall.api_url + "comment/" + item.post_id + "/" + comment_id, function (resp) {
				if (resp.data && resp.data.comments && resp.data.comments.length > 0) {
					var comment = resp.data.comments[0];
					commentItemDetails(comment);
					item.comments.push(comment);
				}
			});
		};

		_this.loadLikedUsersList = function (item, is_comment) {
			if (is_comment) {
				$.post(OTWall.api_url + "clikes", {
					comment_id: item.comment_id
				}, function (resp) {
					if (resp.data) {
						item.like_count(resp.data.like_count - 0);
						item.liked = resp.data.liked;
						buildLikedList(item);
					}
				});
			}
			else {
				$.post(OTWall.api_url + "likes", {
					post_id: item.post_id
				}, function (resp) {
					if (resp.data) {
						item.like_count(resp.data.like_count-0);
						item.liked = resp.data.liked;
						buildLikedList(item);
					}
				});
			}
		};

		var calcPollResult = function (self) {
			var expr = "";
			var total_vote = 0;
			var usr = "";

			$.each(self.post_content.answers, function (key, val) {
				expr = new RegExp("(\\d+)\#" + val.id, "g");
				val.result = self.post_input.match(expr);

				val.result_count = 0;
				val.users = "";

				if (val.result) {
					val.result_count = val.result.length;
					total_vote = self.post_input.match(/(,\d+#\b)(?!.*\1\b)/g).length;

					// User Name in tooltip Begin
					usr = val.result.join(",");
					usr = usr.replace(/#\d+/g, "").replace(/(\d+)/g, function (uid) {
						return uid && OTWall.Users.user_list_by_id[uid] ? OTWall.Users.user_list_by_id[uid].name : "";
					}).replace(/,/g, '\n');
					val.users = usr;
					// User Name in tooltip End
				}
			});
			self.post_content.total_vote = total_vote;
		};
		_this.ContentModel = function (self, parent) {
			if (!self) {
				self = {};
			}

			self._info = {
				full_name: "Unknown",
				user_image: "assets/img/avatar7.jpg"
			};

			var usr = OTWall.Users.user_list_by_id[self.post_by - 0];
			if (usr) {
				self._info.user = usr;
			}

			self.post_date = new Date((self.post_date - 0) * 1000);
			self._info.post_to = "";
			self._info.bg_color = "";
			if (self.post_to && OTWall.Users.group_list_by_id[self.post_to]) {
				self._info.post_to = OTWall.Users.group_list_by_id[self.post_to].name;
				self._info.bg_color = OTWall.Users.group_list_by_id[self.post_to].bg_color ? OTWall.Users.group_list_by_id[self.post_to].bg_color : '';
			}
			self.attachments = OTWall.a(self.attachments || []);
			self.comments = OTWall.a(self.comments || []);
			self.is_new_comments = OTWall.o(false);
			self.newCommentMsg = OTWall.o("");
			self.is_favorite = OTWall.o(self.is_favorite - 0 || 0);
			self.is_follow = OTWall.o(self.is_follow - 0 || 0);
			self.like_count = OTWall.o(self.like_count - 0 || "");
			self.ack_count = OTWall.o(self.ack_count - 0 || "");
			self.comments_count = OTWall.o(self.comments_count - 0 || "");
			self.post_by = OTWall.o(self.post_by - 0 || 0);
			self.show_delete = OTWall.o(false);
			
			if (OTWall.user_id==self.post_by()) {
					self.show_delete(true);
			} else if (OTWall.Users.user_list_by_id[OTWall.user_id].user_role=='A'){
				self.show_delete(true);
			} else if(OTWall.Users.user_list_by_id[OTWall.user_id].user_role=='M' && usr.user_role!='A' && usr.user_role!=OTWall.Users.user_list_by_id[OTWall.user_id].user_role) {
				self.show_delete(true);
			}
			var limit = 2;
			//			self.isCmtLoadMore	= OTWall.o(self.comments().length > limit ? true : false);
			self.isCmtLoadMore = OTWall.o((self.comments_count() && self.comments().length < self.comments_count()) ? true : false);

			self.comments.subscribe(function () {
				self.isCmtLoadMore(self.comments().length < self.comments_count() ? true : false);
			});

			self.comments_count.subscribe(function () {
				self.isCmtLoadMore(self.comments().length < self.comments_count() ? true : false);
			});

			self.award_type = OTWall.o();
			self.award_users = OTWall.a();

			self.tmpl = 'wall-post-' + self.post_type + '-';

			if (self.post_type == POST_TYPES.POLL && self.post_content) {
				self.post_content = JSON.parse(self.post_content);
				self.post_content.result_after_vote = OTWall.o(!!(self.post_content.result_after_vote - 0));
				self.post_content.multiple_choice = OTWall.o(!!(self.post_content.multiple_choice - 0));
				self.post_content.hide_identity = OTWall.o(!!(self.post_content.hide_identity - 0));

				calcPollResult(self);
			}
			else if (self.post_type == POST_TYPES.AWARD) {
				self.award_type(award_types[self.post_content]);
				var award_users = [];
				$.each(self.post_input.split(","), function (key, val) {
					award_users.push(OTWall.Users.user_list_by_id[val]);
				});
				self.award_users(award_users);
			} else if (self.post_type == POST_TYPES.ANNONCEMENT) {
				self.post_content = JSON.parse(self.post_content || '{}');
				self.post_content.ack_required = OTWall.o(!!((self.post_content.ack_required || '') - 0));
			}

			self.is_voted = OTWall.o(!!(self.is_voted - 0));
			self.is_liked = OTWall.o(!!(self.is_liked - 0));
			self.is_acknowledge = OTWall.o(!!(self.is_acknowledge - 0));
			self.is_newpost = OTWall.o(!!(self.is_newpost - 0));
			self._info.liked_users_name	= OTWall.o();
			self._info.liked_users	= OTWall.a();

			buildLikedList(self);
/*
			self._info.ack_users = "";
			if (self.ack) {
				self.ack = self.ack.split(",");
				var ack_users = '';
				for (var i = 0, iLen = self.ack.length; i < iLen; i++) {
					ack_users += OTWall.Users.user_list_by_id[self.ack[i]] ? OTWall.Users.user_list_by_id[self.ack[i]].name + "\n" : "";
				}
				self._info.ack_users = ack_users;
			}
*/
			if (!self.is_voted()) {
				self.is_voted.subscribe(function () {
					calcPollResult(self);
				});
			}

			self._info.prime_image = OTWall.o(null);
			if (self.attachments().length > 0) {
				var prime = null;
				$.each(self.attachments(), function (key, val) {
					if (val.is_image) {
						prime = val;
						return false;
					}
				});
				self._info.prime_image(prime);
			}

			self.pollResult = function (item) {
				if (item.result_after_vote() && !self.is_voted()) {
					return false;
				}
			};
			/*
						// Hash Tag replacement made in ko-handler.js, msgText Handler.
			
						var tagExpr	= /(^|[^a-z0-9_])#([a-z0-9_]+)/i;
						self.post_message	= self.post_message.replace(tagExpr, function(str){
							return '<a href="javascript:;" title="' + str + '">' + str + '</a>';
						});
			*/

			self.deleteComment = function (item) {
				if (confirm('Are you sure to delete this comment?')) {
					$.post(OTWall.api_url + "comment_delete", {
						comment_id: item.comment_id
					}, function (resp) {
						if (resp.data) {
							if (_this.appModel.listingById[item.module_id] && _this.appModel.listingById[item.module_id].comments_count()) {
								var post_item = _this.appModel.listingById[item.module_id];
								post_item.comments_count((post_item.comments_count() - 0) - 1);
							}
							self.comments.remove(item);
						}
					});
				}
			};

			self.likeComment = function (item) {

				var tmp_liked = item.liked + "";
				tmp_liked = tmp_liked.split(',');
				if (!item.is_liked()) {
					tmp_liked.push(OTWall.user_id);
					item.like_count((item.like_count()-0) + 1);
					item.is_liked(true);
					$.post(OTWall.api_url + "comment_like", { comment_id: item.comment_id }).fail(function (resp) {
						tmp_liked.unset(OTWall.user_id+ "");
						item.like_count((item.like_count()-0) - 1);
						item.is_liked(false);
					});
				}
				else {
					item.like_count((item.like_count()-0) - 1);
					item.is_liked(false);
					tmp_liked.unset(OTWall.user_id + "");
					$.post(OTWall.api_url + "comment_unlike", { comment_id: item.comment_id }).fail(function (resp) {
							item.like_count((item.like_count()-0) + 1);
							tmp_liked.push(OTWall.user_id);
							item.is_liked(true);
					});
				}
				item.liked = tmp_liked.join(',');
				buildLikedList(item);
			};

			self.currentImg = OTWall.o(); 
			self.image_popup = function (itm, elem) {
				if (itm == self) {
					$.each(self.attachments(), function (key, attach) {
						if (attach.is_image) {
							self.currentImg(attach);
							return false;
						}
					});
				}
				else {
					self.currentImg(itm);
				}

				if (window.document.documentElement.clientWidth < 768) {
					var attachList=[];
					var index = self.attachments().indexOf(itm);
					$.each(self.attachments(), function(key, attach){
						if (attach.is_image) {
							attachList.push(attach.image_src);
						}
					});

					index = index < 0 ? 0 : index;

					if (window.showImagePopup(attachList, index)) {
						return;
					}
				}

				parent.selectedItem(self);
				parent.addComment(itm, elem);
				$("#img-preview").modal("show");
				return false;
			};

			self.usersListType = OTWall.o('liked_users');
			self.showLikedUsers = function (type) {
				return function(itm, elem){
					self.usersListType(type);
					
					parent.selectedTmpitem(itm);					
					parent.selectedItem(self);
					
					// parent.addComment(itm, elem);
					$("#liked-preview").modal("show");
					return false;
				}
			};

			self.prev = function () {
				var index = self.attachments.indexOf(self.currentImg()) - 1;
				if (index > -1) {
					self.currentImg(self.attachments()[index]);
				}
			};
			self.next = function () {
				var index = self.attachments.indexOf(self.currentImg()) + 1;
				if (index < self.attachments().length) {
					self.currentImg(self.attachments()[index]);
				}
			};
		};

		// New post model.
		_this.MessageModel = function (data) {
			var self = this;

			data = data || {};
			/*
						var oldVal	= ["all"];
						self.post_to	= OTWall.a(oldVal);
						self.post_to.subscribe(function(newVal){
							if (!newVal.length)
							{
								oldVal	= ["all"];
								self.post_to(oldVal);
								return;
							}
							if (oldVal[0] == "all" && newVal.length > 1)
							{
								self.post_to.remove("all");
							}
							else if ((newVal[0] == "all" && newVal.length > 1) || newVal.length <= 0)
							{
								self.post_to(["all"]);
							}
			
							oldVal	= newVal;
						});
			*/

			// Common fields begins
			self.post_type = OTWall.o(data.post_type || "M");
			self.post_to = OTWall.o("all");
			var lastVal = "all";
			self.post_to.subscribe(function (newVal) {
				if (!newVal) {
					self.post_to(lastVal);
					return;
				}
				if ('all' == newVal) {
					_this.appModel.reset_users();
				} else {
					lastVal = newVal;
					var tmp_users = [];
					var pro_id = newVal.replace('P_','') - 0;
					
					if (OTWall.Users.groups[0].users && OTWall.Users.groups[0].users[pro_id]) {
						var tmp_grp_users = OTWall.Users.groups[0].users[pro_id].split(',');
						$.each(tmp_grp_users, function (key, val) {
							var usr = OTWall.Users.user_list_by_id[val] || [];
							if (usr['is_active'])
								tmp_users.push(usr);
						});
					}

					_this.appModel.group_users(tmp_users);
				}
			});

			self.post_subject = OTWall.o();
			self.post_message = OTWall.o();
			self.post_attachment = OTWall.o();

			/*
						self.is_focused	= OTWall.o(false);
						self.onMsgFocus	= function(){
							self.is_focused(true);
						};
			*/
			//	{imgSelect:true, onMouseDown:onUserBoxMouseDown, onMouseUp:onUserBoxMouseUp, onChoiceClick:onUserBoxClick}

			self.chosen_options = {
				menu: OTWall.Users
			};

			// File API Begins.
			self.fileList	= [];
			self.fileapi	= {
				url: OTWall.api_url + 'attachment',
				dataType: 'json',
				progressall: function (e, data) {
					// var progress = parseInt(data.loaded / data.total * 100, 10);
					// $('#progress .progress-bar').css('width', progress + '%');
				},
				autoUpload: false,
				onFileuploadadd: function(e, data){
					self.fileList.push(data);
				},
				onClear: function(){

					self.fileList	= [];
				},
				onRemoveFile: function(data){
					self.fileList.splice(self.fileList.indexOf(data), 1);
				},
//				acceptFileTypes: /(\.|\/)(gif|jpe?g|png)$/i,
				maxFileSize: 5000000	// 5 MB
			};

			// File API End.

			// Common fields ends
			// Announcement fileds begins
			self.is_announcement	= OTWall.o(data.post_type == POST_TYPES.ANNONCEMENT);
			self.ack_required		= OTWall.o(false);
			// Announcement fileds end
			// Poll fields begins
			self.is_poll = OTWall.o(data.post_type == POST_TYPES.POLL);
			self.post_type.subscribe(function (newVal) {
				self.is_poll(newVal == POST_TYPES.POLL);
				self.is_announcement(newVal == POST_TYPES.ANNONCEMENT);
				self.post_to.valueHasMutated();
			});
			self.multiple_choice = OTWall.o(false);
			self.result_after_vote = OTWall.o(true);
			self.hide_identity = OTWall.o(true);
			// self.question	= OTWall.o();
			self.answers = OTWall.a([]);
			self.addAnswer = function () {
				self.answers.push({
					answer: OTWall.o("")
				});
			};
			self.answerChanged = function (itm) {
				if ($.trim(itm.answer()) && self.answers().length - 2 == self.answers().indexOf(itm)) {
					self.addAnswer();
				}
			};
			self.delete_answer = function (itm) {
				self.answers.remove(itm);
				if (self.answers().length < 2)
					self.addAnswer();
			};
			self.addAnswer();
			self.addAnswer();
			self.voteResult = function (item) {
				// post_input
			};
			// Poll fields end
			// Awards fields begins
			self.award_users = OTWall.a([]);
			self.award_type = OTWall.o(data.award_type);
			self.setAwardType = function (item) {
				self.award_type(item);
			};
			// Awards fields end
		};

		_this.Trends = function () {
			$.get(OTWall.api_url + "trends", function (resp) {
				var trends = [], elements = [];
				if (resp.data && resp.data.length > 0)
				{
					$.each(resp.data, function (key, val) {
						elements.push(val.name);
						trends.push({
							name: val.name,
							value: val.tag_id,
							bg_color: '',
							class_name: '',
							type: 'trends',
							count: OTWall.o(val.tag_count)
						});
					});
				}
				_this.appModel.trends(trends);
				// apply trends
				$('#search_input').textcomplete([{ // html
					match: /\B#([\-+\w]*)$/,
					search: function (term, callback) {
						callback($.map(elements, function (element) {
							return element.toLowerCase().indexOf(term.toLowerCase()) === 0 ? element : null;
						}));
					},
					index: 1,
					replace: function (element) {
						// $(this.el).attr('id')
						return '#' + element + ' ';
					}
				}]);
				/*$('#post_message').textcomplete([{ // trends
					match: /\B#([\-+\w]*)$/,
					search: function (term, callback) {
						callback($.map(elements, function (element) {
							return element.toLowerCase().indexOf(term.toLowerCase()) === 0 ? element : null;
						}));
					},
					index: 1,
					replace: function (element) {
						return '#' + element + ' ';
					}
				},{ // user tag
					match: /\B@([\-+\w]*)$/,
					search: function (term, callback) {
						callback($.map(OTWall.Users.user_list, function (element) {
							return element.name.toLowerCase().indexOf(term.toLowerCase()) === 0 ? element : null;
						}));
					},
					index: 1,
					replace: function (element) {
						return '<a class="tag_user" id="'+element.user_id+'">@' + element.name + '</a> ';
					},
					template: function (element) {
						return element.name;
					}
				}]);*/
			});
		}

		_this.sock = null;
		var new_post = 0;
		_this.subscribeFn = function (wall_type) {
			new_post = 0;
			user_notification_count = user_notification_count || 0;
			_this.new_post_id = 0;
			_this.sock.type = wall_type;
			_this.sock.sendMessage({
				event: 'subscribe_wall',	// Subscribe for group
				wall_type: wall_type,
				entity_id: OTWall.entity_id
			});
		};

		window.getHash = function (entity_id, user_id) {
			// var salt	= "0123456789abcdef".shuffle().substr(0, 8);
			var salt = "9b67a3c8";
			var str = (salt + entity_id + user_id + "").sha256();
			return (salt + str).substr(0, 32);
		};

		/**
			wall_type will have the group_id, trends_name
		*/
		window.onmessage = function(msg , show_new){
			show_new = show_new || false;
			
			if (typeof msg === "string")
			{
				var data = JSON.parse(msg);
				data.show_new = show_new;
				msg = JSON.stringify(data);

				_onmessage({
					data:msg
				});
			}
		};
		var _onmessage = function(e) {
			var data = JSON.parse(e.data);
			console.log("New Data Received : ", data);
			if (data.posted_by - 0 == OTWall.user_id - 0) {
				return;
			}

			if (data.module_id) {
				if ($('#p_' + data.module_id).length) {
					if (data.module_type == 'O' && _this.appModel.listingById[data.module_id]) {
						var item = _this.appModel.listingById[data.module_id];
						if (data.deleted) {
							_this.appModel.listing.remove(item);
							return;
						}						
						switch (data.module_action) {
							case 'C':
								item.comments_count((item.comments_count() - 0) + 1);
								_this.loadComment(item, data.comment_id);
								break;
							case 'L':
								item.like_count((item.like_count() - 0) + 1);
								_this.loadLikedUsersList(item);
								break;
							case 'A':
								item.ack_count((item.ack_count() - 0) + 1);
								break;
						}
						// var totalCount	= (item.comments_count()-0) + (item.like_count()-0) + (item.ack_count()-0);
					} else if (data.module_type == 'C') {
						var item = _this.appModel.listingById[data.module_id];
						var rem_cmt = null;
						$.each(item.comments(), function (key, val) {
							if (val.comment_id - 0 == data.comment_id - 0) {
								if (data.deleted) {
									rem_cmt = val;
									return false;									
								} else {
									val.like_count((val.like_count() - 0) + 1);
									_this.loadLikedUsersList(val, true);
									return false;
								}
							}
						});

						if (rem_cmt) {
							item.comments_count((item.comments_count()-0) -1);
							item.comments.remove(rem_cmt);
						}
					}
					user_notification_count++;
					OTWall.ExtNotify(user_notification_count);
					$('#notification .user-notify-cnt').show();
					return;
				}

				if (!data.comment_id) {

					if (_this.appModel.activeMenu().value != data.wall_type) {
						var item = _this.appModel.menuById[data.wall_type];
						if (item) {
							item.count((item.count() - 0) + ((data.deleted)?-1:1));
						}
						_this.appModel.reset_count();
						if (_this.appModel.activeMenu().value != 'all') {
							return;
						}
					}

					_this.new_post_id = _this.new_post_id ? _this.new_post_id : data.module_id;
					console.log(_this.new_post_id, data.module_id);
					if (data.module_type == 'O' && data.deleted && _this.new_post_id<=data.module_id) {
						new_post--;
						OTWall.PostNotify(new_post);
						$('#new_notification span').text('New posts : ' + new_post);
						if (!new_post)
							$('#new_notification').hide();
					} else {
						if (data.show_new && data.show_new == 'true') {
							_this.appModel.showNew({hold_reset:true});
							_this.appModel.menuById['office'].count(0);
							_this.appModel.reset_count();
						} else {
							new_post++;
							OTWall.PostNotify(new_post);
							$('#new_notification span').text('New posts : ' + new_post);
							$('#new_notification').show();
						}
					}
				}
			}
			else {
				user_notification_count++;
				$('#notification .user-notify-cnt').show();
			}
		}
		// oum 
		window.onActive=function(){
		_onActive();
		}
		var _onActive = function() {
			if (_this.new_post_id) {
			_this.appModel.showNew({hold_reset:true});
			_this.appModel.menuById['office'].count(0);
			_this.appModel.reset_count();
			}
		}
		_this.initSocket = function (wall_type) {
			wall_type = wall_type || "all";
			/*
						if (_this.sock)
						{
							_this.subscribeFn(wall_type);
							return;
						}
			*/
			_this.sock = new window[OTWall.isWebSocket ? 'WebSocket' : 'SockJS'](OTWall.sock_url + 'notification');
			_this.sock.isOpend = false;
			_this.sock.onopen = function () {
				_this.sock.isOpend = true;
				_this.subscribeFn(wall_type);

				_this.sock.sendMessage({
					event: 'subscribe_user',	// Subscribe for User
					user_id: OTWall.user_id,
					entity_id: OTWall.entity_id,
					uid: window.getHash(OTWall.user_id, OTWall.entity_id) || OTWall.uid
				});
			};
			_this.sock.onmessage = _onmessage;
			_this.sock.onerror = function () {
				_this.sock.isOpend = false;
				console.log('Connection Error !!!');
			};
			_this.sock.onclose = function () {
				_this.sock.isOpend = false;
				console.log('Connection Closed !!!');
			};
			_this.sock.sendMessage = function (msg) {
				_this.sock.send(JSON.stringify(msg));
			}
		};

		_this.loadDataAjax = function (self, url) {
			var page = 0;
			self.no_post(false);

			if (OTWall.post_id - 0) {
				url = "post/" + OTWall.post_id;
				self.hide_new(true);
				OTWall.post_id = 0;
			} else {
				self.hide_new(false);
			}

			_this.url = OTWall.api_url + (url || "list/all");
			/*
				var isInIFrame = (window.location != window.parent.location);
				if (!isInIFrame)
				{
					_this.initSocket(_this.url.substr(_this.url.lastIndexOf("/")+1));
				}
			*/

			var win = postContainer;
			/*var menu = document.querySelector('#new_notification');
			var menuPosition;
			if (menu)
			{
				menuPosition = menu.getBoundingClientRect().top;
			}*/
			win.unbind("scroll");
			var onScroll = function (e) {
				if (_this.url.indexOf('/post/') != -1) return;

				if ((win.scrollTop() + win.height()) > win.get(0).scrollHeight-200)
				{
					win.unbind("scroll");
					console.log("Load More Called.");
					$.get(_this.url + "/" + ++page, function (resp) {
						if (!resp.data || !resp.data.posts) {
							// self.no_post(true);
							return false;
						}

						_this.loadData(resp.data, self, true);
						win.bind("scroll", onScroll);
						// setMasonry();
					});
				}
			};

			$.get(_this.url, function (resp) {
				self.listing([]);
				OTWall.PostNotify(0);
				_this.loadData(resp.data, self);
				// _this.Trends();

				if (resp.data && resp.data.posts)
					win.bind("scroll", onScroll);

				//setTimeout(function(){
				// setMasonry();
				//}, 800);
			});
		};

		_this.init = function () {
			
			// Prepare & build users select box module.
			OTWall.Users.render();

			postContainer = $("#post-container");

			_this.appModel = new _this.ListModel();
			ko.setTemplateEngine(new ko.nativeTemplateEngine());
			ko.applyBindings(_this.appModel, $("#main-container").get(0));
			$("#menu").show();
			if (OTWall.get_notf_count) {
				$.get(OTWall.api_url + "get_count", function (resp) {
					if (resp.data && resp.data.user_notification_count-0) {
						user_notification_count = resp.data.user_notification_count;
						OTWall.ExtNotify(user_notification_count);
						$('#notification .user-notify-cnt').show();
					}
				});
			}
			_this.loadDataAjax(_this.appModel);
			_this.Trends();
			if (OTWall.wall_type!='OM') {
				setInterval(function () {
					if (!_this.sock || !_this.sock.isOpend) {
						console.log("Socket trying...");
						_this.initSocket();
					}
				}, 3E4);
				_this.initSocket();
			}

			OTWall.ExtNotify(0);

			// imagesLoaded

			var menu = document.querySelector('#new_notification');
			window.addEventListener('scroll', function () {
				var w = $(window);
				var w_top = Math.max(0, 225 - $(window).scrollTop());
				$(".new_notification_grid").css("top", w_top);
				$(".new_notification_list").css("top", w_top);

				if (!w_top) {
					$(".new_notification_grid").css({"position":"fixed", "left":"30%"});
					$(".new_notification_list").css({"position":"fixed", "left":"30%"});
					$(".new_notification_grid i").removeClass('icon-chevron-down');
					$(".new_notification_list i").removeClass('icon-chevron-down');
					$(".new_notification_grid i").addClass('icon-chevron-up');
					$(".new_notification_list i").addClass('icon-chevron-up');

				} else {
					$(".new_notification_grid").css({"position":"static", "left":"0"});
					$(".new_notification_list").css({"position":"static", "left":"0"});
					$(".new_notification_grid i").removeClass('icon-chevron-up');
					$(".new_notification_list i").removeClass('icon-chevron-up');
					$(".new_notification_grid i").addClass('icon-chevron-down');
					$(".new_notification_list i").addClass('icon-chevron-down');

				}
//				$(".boxscroll").getNiceScroll().resize();

				// after scroll check post in viewport
				clearTimeout($.data(this, "scrollCheck"));
				$.data(this, "scrollCheck", setTimeout(function () {
					if ($('#listing *[id^="p_"].unread').length > 0) {
						$('#listing *[id^="p_"].unread').each(function () {
							if ($(this).visible(true, true)) {
								var post_id = $(this).attr('id').replace('p_', '');
								if (post_id && _this.appModel.listingById[post_id]) {
									var wall_type = _this.appModel.listingById[post_id].post_to ? _this.appModel.listingById[post_id].post_to : 'office';
									_this.appModel.listingById[post_id].is_newpost(0);
									if (_this.appModel.menuById[wall_type] && _this.appModel.menuById[wall_type].count() - 0) {
										_this.appModel.menuById[wall_type].count(_this.appModel.menuById[wall_type].count() - 1);
										_this.appModel.reset_count();
									}
								}
							}
						});
					}
				}, 500));
			});
/*
			$(".boxscroll").niceScroll({
				cursorcolor: "#888",
				cursorwidth: 10,
				boxzoom: true,
				dblclickzoom: false
			});
*/
			// default focus in subject
			var iframe = $('iframe');
			var ele    = $('#post_subject');

			if (iframe && !ele.length) {
				ele =  $('#post_subject', iframe.contents());
			} 
			if (ele) {
				setTimeout(function() {ele.focus();}, 100);
			}
		};
	}
})(window.OTWall);
